# -*- coding: iso-8859-15 -*-

import sys, time, traceback
import host

### BUILT-IN

def init():
    # reroute streams
    sys.stdout = stdout()
    sys.stderr = stderr()

### METHODS

def exception():
    exc_type, exc_value, exc_traceback = sys.exc_info()

    sys.stderr.write("Exception occurred on: " + time.strftime("%Y-%m-%d %H:%M"))

    sys.stderr.write("Traceback (most recent call only):")

    while exc_traceback:
        # last stack
        last_traceback = exc_traceback
        # next stack
        exc_traceback = exc_traceback.tb_next

    # last stack
    exc_file = str(last_traceback.tb_frame.f_code.co_filename).replace("/", "\\")
    exc_line = str(last_traceback.tb_lineno)
    exc_name = str(last_traceback.tb_frame.f_code.co_name)
    sys.stderr.write("  File \"" + exc_file + "\", line " + exc_line + ", in " + exc_name)

    # code line
    file = open(exc_file, 'r')
    exc_code = file.readlines()[int(exc_line)-1].strip(" ")
    file.close()
    sys.stderr.write("    " + exc_code)

    # exception type
    exc_type = str(exc_type).replace("exceptions.", "")
    exc_value = str(exc_value)
    sys.stderr.write(exc_type + ": " + exc_value)

### CLASSES

class stdout(object):
    def __init__(self): pass
    
    def flush(self): pass
    
    def close(self): pass
    
    def write(self, string): pass

class stderr(object):
    def __init__(self):
        self.file = open("%s/python/game/debug.txt" % host.sgl_getModDirectory(), 'w')

    def flush(self):
        self.file.flush()

    def close(self):
        self.file.close()

    def write(self, string):
        for line in string.splitlines():
            # write to file
            time = "%.3f" % host.timer_getWallTime()
            self.file.write(time + ": " + line + "\n")
            # write to chat
            line = line.replace("\"", "'")
            host.rcon_invoke("game.sayall \"%s\"" % line)
