#Game Play Mode: Pirates
#Mod: BFP2 (http://www.bfpirates.com)
#
#Authors: PiratePlunder idea by 1/2Hawk
#

# Server variables - change to your preference 0->Off 1->On

g_useAutoBalance = 1                                                            #Use autobalance on non-zombie rounds
g_usePeglegLocator = 1                                                          #Show position of a random pegleg every 10seconds
g_ctfFlagstoWin = 4                                                             #Number of CTF needed to win a round
g_timeForDroppedFlagsToReturn = 30                                              #Dropped flag return time

#
# Do not change anything below this point!
#

g_flag_playerInx = [-1,-1,-1]
g_flag_otherTeam = [0,2,1]
g_flag_names = ["noTeamFlag", "MyRedFlag", "MyBlueFlag"]                        #Custom CTF flag names
g_flag_zombie = ["ZombieBase", "nonZomnieBase"]                                 #Custom Zombie flag names
g_team_names = ["neutral", "Undead", "Pegleg"]                                  #Custom team names
g_carryFlagNames = ["GrayFlagPCO", "BlueCarryFlag", "RedCarryFlag"]
g_soldier_types =["ud_gunrrpeg","pl_gunr","ud_shrp_ctf","ud_radrrpeg_ctf","ud_gunr_ctf","ud_surgrpeg_ctf","pl_shrppeg_ctf","pl_radr_ctf","pl_gunr_ctf","pl_carppeg_ctf","pl_surg_ctf"]

g_intervalNum = 0                                                              #Timer looping variable

g_miniMapFlagNames = ["GrayFlagPCO","BlueMiniMapFlag","RedMiniMapFlag"]         #Flag display implementation
g_timeDroppedFlag = [-1,-1,-1]                                                  #Dropped flag implementation

g_bfp2gamemodetype = 0                                                          #Initially we set bfp2gamemodetype to 0 as default
g_bfptgamemodenames = ["Conquest", "CaptureTheFlag", "Zombie", "Armada"]        #Names of gamemodes
g_bfp2gamestate = 2                                                             #Gamemode toggle

g_zombieTimer = -1                                                              #Timer for zombie mode
g_zombiePlayers = [0,0,0]                                                       #Players for each team

g_ctfFlagPos = (0.00,0.00,0.00)                                                 #Postion to reset flags to

g_ShowPlayerDamage = 0                                                          #By default dont show player damage

g_armadaPointsX = [0,0,0,0,0,0,0,0,0,0]                                         #Stores potential Armada flag positions
g_armadaPointsY = [0,0,0,0,0,0,0,0,0,0] 
g_armadaPointsZ = [0,0,0,0,0,0,0,0,0,0]
g_armadaIdPoints = [0,0,0,0,0,0,0,0,0,0]                                        #Stores Armada Flag Trigger IDs
g_armadaNumPoints = 0                                                           #Number of Armada flag positions
g_armadaCurPoint = 0                                                            #Current Armada flag position
g_armadaPlayerCount = [0,0,0]                                                   #Players in Armada Trigger Area [0] is used for capping too
g_armadaCP = {}

GeneralTimer = None
CTFTimer = None
ZombieTimer = None
ArmadaTimer = None

CarryFlagCP_Object = None

TAKEOVERTYPE_CAPTURE = 1                                                        #Set constants
TAKEOVERTYPE_NEUTRALIZE = 2

SCORE_CAPTURE = 2
SCORE_NEUTRALIZE = 2
SCORE_CAPTUREASSIST = 1
SCORE_NEUTRALIZEASSIST = 1
SCORE_DEFEND = 1

Top = 0
Middle = 1
Bottom = 2

import host                                                                     #Import modules
import bf2
import math
import bf2.Timer
import random
import game.debug as debug
import socket

from socket import *
from game.stats.constants import *
from game.scoringCommon import addScore, RPL
from bf2 import g_debug

g_controlPoints = []                                                            #Cache, as this map won't change

def onChatMessage(playerId, text, channel, flags):
        global first
        global second
        
        if text.find('!mode') == 0:                                           #Display the gamemode
                if g_bfp2gamemodetype == 3:                                     #Gamemode is Zombie
                        prnt ("Gamemode running: gpm_pirates::" + str( g_bfptgamemodenames[ g_bfp2gamemodetype ] ) + "  NumPoints: " + str( g_armadaNumPoints  ) )
                else:
                        prnt ("Gamemode running: gpm_pirates::" + str( g_bfptgamemodenames[ g_bfp2gamemodetype ] ) ) 
        elif text.find('!nextmap') == 0:                                        #Display the next map in rotation
                prnt ("The next map is " + host.rcon_invoke('maplist.list').splitlines()[int(host.rcon_invoke('admin.nextLevel').strip())].split()[1].strip('"').replace('_', ' ').title() )

def init():
        host.registerGameStatusHandler(onGameStatusChanged)                     #Events hook
        if host.sgl_getIsAIGame() == 1:
                host.sh_setEnableCommander(0)
        else:
                host.sh_setEnableCommander(0)
        host.registerHandler('TimeLimitReached', onTimeLimitReached, 1)
        
        if g_debug: print "gpm_pirates.py initialized"	

def deinit():
        global g_controlPoints      
       
        g_controlPoints = []
        host.unregisterGameStatusHandler(onGameStatusChanged)
        if g_debug: print "gpm_pirates.py uninitialized"
        
def onGameStatusChanged(status):
        
        global g_controlPoints
        global g_bfp2gamemodetype
        global g_bfp2gamestate
        global g_zombieTimer
        global g_ctfFlagsPositioned
        global g_flag_playerInx 
        global g_armadaNumPoints
        global g_armadaCP
        
        global GeneralTimer
        global CTFTimer
        global ZombieTimer
        global ArmadaTimer
        
        if status == bf2.GameStatus.Playing:
                
                # Set gamemode to cq by default
                g_bfp2gamemodetype = 0
                g_bfp2gamestate = 0
                               
                # Set autobalance on by default
                print host.rcon_invoke("sv.autoBalanceTeam " + str(g_useAutoBalance))   
                
                # Routine for checking if map is Armada
                arm_points = bf2.objectManager.getObjectsOfTemplate('armadaDummyObject')
                if len(arm_points) > 1:                                               # Gamemode is Armada
                        g_bfp2gamemodetype = 3
                
                #Add control point triggers
                g_controlPoints = bf2.objectManager.getObjectsOfType('dice.hfe.world.ObjectTemplate.ControlPoint')
                for obj in g_controlPoints:
                        
                        if obj.templateName == "ArmadaFlag":
                                g_armadaCP = obj
                        
                        if obj.templateName in g_flag_names:                    # Gamemode is CTF
                                g_bfp2gamemodetype = 1
                                g_ctfFlagsPositioned = 0
                        
                        if obj.templateName in g_flag_zombie:                   # Gamemode is Zombie - set autobalance off
                                g_bfp2gamemodetype = 2
                                print host.rcon_invoke("sv.autoBalanceTeam 0")
                        
                        if not obj.templateName in g_carryFlagNames:            # Carry flags don't have triggers
                                radius = float(obj.getTemplateProperty('radius'))
                                isHemi = int(obj.cp_getParam('isHemisphere'))
                                if isHemi != 0:
                                        id = bf2.triggerManager.createHemiSphericalTrigger(obj, onCPTrigger, '<<PCO>>', radius, (1, 2, 3))
                                else:
                                        id = bf2.triggerManager.createRadiusTrigger(obj, onCPTrigger, '<<PCO>>', radius, (1, 2, 3))
                                obj.triggerId = id
                                obj.lastAttackingTeam = 0
                                if obj.cp_getParam('team') > 0:
                                        obj.flagPosition = Top
                                else:
                                        obj.flagPosition = Bottom
                                        
                
                host.registerHandler('ControlPointChangedOwner', onCPStatusChange)
                
                #Setup ticket system
                ticketsTeam1 = calcStartTickets(bf2.gameLogic.getDefaultTickets(1))
                ticketsTeam2 = calcStartTickets(bf2.gameLogic.getDefaultTickets(2))
                bf2.gameLogic.setTickets(1, ticketsTeam1)
                bf2.gameLogic.setTickets(2, ticketsTeam2)
                bf2.gameLogic.setTicketState(1, 0)
                bf2.gameLogic.setTicketState(2, 0)
                bf2.gameLogic.setTicketLimit(1, 1, 0)
                bf2.gameLogic.setTicketLimit(2, 1, 0)
                bf2.gameLogic.setTicketLimit(1, 2, 10)
                bf2.gameLogic.setTicketLimit(2, 2, 10)
                bf2.gameLogic.setTicketLimit(1, 3, int(ticketsTeam1*0.1))
                bf2.gameLogic.setTicketLimit(2, 3, int(ticketsTeam2*0.1))
                bf2.gameLogic.setTicketLimit(1, 4, int(ticketsTeam1*0.2))
                bf2.gameLogic.setTicketLimit(2, 4, int(ticketsTeam2*0.2))
                
                if g_bfp2gamemodetype == 0:                                     #Gamemode is CQ
                        g_bfp2gamestate = 2
                        host.registerHandler('TicketLimitReached', onTicketLimitReached)
                        
                        #This is our timer for boarding vessels                                           
                        GeneralTimer = timer.loop(1, onGeneralTimer, None)
                        
                        updateTicketLoss()
                
                if g_bfp2gamemodetype == 1:                                     #Gamemode is CTF
                        g_bfp2gamestate = 2
                        bf2.gameLogic.setTickets(1, 1000)
                        bf2.gameLogic.setTickets(2, 1000)	
                        bf2.gameLogic.setTicketState(1, 0)
                        bf2.gameLogic.setTicketState(2, 0)	
                        bf2.gameLogic.setTicketLimit(1, 1, 0)                   #Low limit target
                        bf2.gameLogic.setTicketLimit(2, 1, 0)
                        bf2.gameLogic.setTicketLimit(1, 2, 1)
                        bf2.gameLogic.setTicketLimit(2, 2, 1)
                        
                        #This is our timer for boarding vessels                                           
                        GeneralTimer = timer.loop(1, onGeneralTimer, None)
                        
                        #This is our timer for ctf                                          
                        CTFTimer = timer.loop(1, onCTFTimer, None)
                
                if g_bfp2gamemodetype == 2:                                     #Gamemode is Zombie
                	g_bfp2gamestate = 0
                	g_zombieTimer = -1	
                	bf2.gameLogic.setTickets(1, 1)
                	bf2.gameLogic.setTickets(2, 1)			
                	bf2.gameLogic.setTicketState(1, 0)
                	bf2.gameLogic.setTicketState(2, 0)	
                	bf2.gameLogic.setTicketLimit(1, 1, 0)
                	bf2.gameLogic.setTicketLimit(2, 1, 0)
                	bf2.gameLogic.setTicketLimit(1, 2, 1)
                	bf2.gameLogic.setTicketLimit(2, 2, 1)
                	
                	host.registerHandler('TicketLimitReached', onTicketLimitReached)
                	
                	#This is our timer for boarding vessels                                           
                	GeneralTimer =  timer.loop(1, onGeneralTimer, None)
                	
                	#This is our timer for zombie                                        
                	ZombieTimer = timer.loop(1, onZombieTimer, None)
             
                if g_bfp2gamemodetype == 3:                                     #Gamemode is Armada
                        g_bfp2gamestate = 2
                        host.registerHandler('TicketLimitReached', onTicketLimitReached)
                        
                        #This is our timer for boarding vessels                                           
                        GeneralTimer =  timer.loop(1, onGeneralTimer, None)
                        
                        #This is our timer for armada                                        
                        #ArmadaTimer = timer.loop(1, onArmadaTimer, None)
                
                #Player events
                host.registerHandler('PlayerDeath', onPlayerDeath)
                host.registerHandler('PlayerKilled', onPlayerKilled)
                host.registerHandler('PlayerSpawn', onPlayerSpawn)
                host.registerHandler('EnterVehicle', onEnterVehicle)
                host.registerHandler('ExitVehicle', onExitVehicle)
                host.registerHandler('PlayerDisconnect', onPlayerDisconnect)
                host.registerHandler('PlayerConnect', onPlayerConnect,1)
                host.registerHandler('PlayerChangeTeams', onPlayerChangeTeams)
                host.registerHandler('ChatMessage', onChatMessage)
                
                #Even teams as they may be uneven after zombie round
                team = 1
                for player in bf2.playerManager.getPlayers():
                        if team == 1:
                                player.setTeam(1)
                                team = 2
                        else:
                                player.setTeam(2)
                                team = 1
                
                if g_debug: print ("Pirates:" + str( g_bfptgamemodenames[ g_bfp2gamemodetype ] ) + " gamemode initialized.")
                
                #Get rank of any connected players
                for player in bf2.playerManager.getPlayers():
                        if player.stats.profileId != 0:
                                playerData = get_rank(player.stats.profileId)
                                #bf2.gameLogic.sendRankEvent(player, int(playerData.split(":")[0]), 0)
                                player.stats.rank = int(playerData.split(":")[0])
                
                #set servervariable to gamemode
                print host.rcon_invoke("gamelogic.supplyDropNumSecsToLive " + str(g_bfp2gamemodetype))
                print host.rcon_invoke("gamelogic.supplyDropHeight " + str(g_bfp2gamestate))
                
        else:
                
                bf2.triggerManager.destroyAllTriggers()                         #Clean up
                
                g_bfp2gamestate = 0
                g_zombieTimer = -1
                g_flag_playerInx = [-1,-1,-1]
                
                print host.rcon_invoke("gamelogic.supplyDropHeight " + str(g_bfp2gamestate))
                
                bf2.triggerManager.destroyAllTriggers()
                g_controlPoints = []
                
                try:
                        GeneralTimer.abort()
                        GeneralTimer = None
                except:
                        if g_debug: debug.exception()
                try:
                        CTFTimer.abort()
                        CTFTimer  = None
                except:
                        if g_debug: debug.exception()     
                try:
                        ZombieTimer.abort()
                        ZombieTimer  = None
                except:
                        if g_debug: debug.exception()  
                try:
                        ArmadaTimer.abort()
                        ArmadaTimer = None
                except:
                        if g_debug: debug.exception()  

def calcStartTickets(mapDefaultTickets):

	return int(mapDefaultTickets * (bf2.serverSettings.getTicketRatio() / 100.0))
	
def onTimeLimitReached(value):
        
        team1tickets = bf2.gameLogic.getTickets(1)
        team2tickets = bf2.gameLogic.getTickets(2)
        
        winner = 0
        victoryType = 0
        if team1tickets > team2tickets:
                winner = 1
                victoryType = 3
        elif team2tickets > team1tickets:
                winner = 2
                victoryType = 3
        if g_bfp2gamemodetype == 1:                                     #mode is CTF
                bf2.gameLogic.setTickets(2 , (bf2.gameLogic.getTickets(2) - 1000))
                bf2.gameLogic.setTickets(1 , (bf2.gameLogic.getTickets(1) - 1000))
        host.sgl_endGame(winner, victoryType)

#Update ticket system
def updateTicketLoss():
	areaValueTeam1 = 0
	areaValueTeam2 = 0
	totalAreaValue = 0
	numCpsTeam0 = 0
	numCpsTeam1 = 0
	numCpsTeam2 = 0
	
	#Calculate control point area value for each team
	for obj in g_controlPoints:
		team = obj.cp_getParam('team')
		if team == 1:
			areaValueTeam1 += obj.cp_getParam('areaValue', team)
			totalAreaValue += areaValueTeam1
			numCpsTeam1 += 1
		elif team == 2:
			areaValueTeam2 += obj.cp_getParam('areaValue', team)
			totalAreaValue += areaValueTeam2
			numCpsTeam2 += 1
		else:
			numCpsTeam0 += 1
			totalAreaValue += 0
	#Check if a team has no control points
	if numCpsTeam1 == 0 or numCpsTeam2 == 0:
		if numCpsTeam1 == 0:
			losingTeam = 1
			winningTeam = 2
		else:
			losingTeam = 2
			winningTeam = 1
		#Check if there is anyone alive
		foundLivingPlayer = False
		for p in bf2.playerManager.getPlayers():
			if p.getTeam() == losingTeam and p.isAlive():
				foundLivingPlayer = True
				break
		if not foundLivingPlayer:
			#Drop tickets
			ticketLossPerSecond = bf2.gameLogic.getDefaultTicketLossAtEndPerMin()
			bf2.gameLogic.setTicketChangePerSecond(losingTeam, -ticketLossPerSecond)
			bf2.gameLogic.setTicketChangePerSecond(winningTeam, 0)
			return
	#Update ticket loss
	team1AreaOverweight = areaValueTeam1 - areaValueTeam2
	percentualOverweight = 1.0
	if totalAreaValue != 0:
		percentualOverweight = abs(team1AreaOverweight / totalAreaValue)
	ticketLossPerSecTeam1 = calcTicketLossForTeam(1, areaValueTeam2, -team1AreaOverweight)
	ticketLossPerSecTeam2 = calcTicketLossForTeam(2, areaValueTeam1, team1AreaOverweight)
	bf2.gameLogic.setTicketChangePerSecond(1, -ticketLossPerSecTeam1)
	bf2.gameLogic.setTicketChangePerSecond(2, -ticketLossPerSecTeam2)


	
#Actual ticket loss calculation function
def calcTicketLossForTeam(team, otherTeamAreaValue, otherTeamAreaOverweight):
	if otherTeamAreaValue >= 100 and otherTeamAreaOverweight > 0:
		ticketLossPerSecond = (bf2.gameLogic.getDefaultTicketLossPerMin(team) / 60.0) * (otherTeamAreaOverweight / 100.0)
		return ticketLossPerSecond
	else:
		return 0
	
DOWNWARDS = -1
UPWARDS = 1	

#Called when tickets reach a predetermined limit (negative value means that the tickets have become less than the limit)
def onTicketLimitReached(team, limitId):
        
        if g_bfp2gamemodetype == 0 or g_bfp2gamemodetype == 3: #Conquest or Armada modes
                if (limitId == -1):
                        if (team == 1):
                                winner = 2
                        elif (team == 2):
                                winner = 1
                        bf2.gameLogic.setTicketState(1, 0)
                        bf2.gameLogic.setTicketState(2, 0)
                        host.sgl_endGame(winner, 3)
                #Update ticket state
                else:
                        updateTicketWarning(team, limitId)
        if g_bfp2gamemodetype == 2 and g_bfp2gamestate == 2: #Gamemode is zm and game is being played
                if (limitId == -1):
                        if (team == 1):
                                winner = 2
                        elif (team == 2):
                                winner = 1
                        bf2.gameLogic.setTicketState(1, 0)
                        bf2.gameLogic.setTicketState(2, 0)
                        host.sgl_endGame(winner, 3)
                #Update ticket state
                else:
                        updateTicketWarning(team, limitId)

#Called when the ticket state should be updated (for triggering messages and sounds based on tickets left)
def updateTicketWarning(team, limitId):

	oldTicketState = bf2.gameLogic.getTicketState(team)
	newTicketState = 0
	
	if (oldTicketState >= 10):
		newTicketState = 10		
	if (limitId == -2):
		newTicketState = 10
	elif (limitId == 2):
		newTicketState = 0		
	elif (limitId == -3):
		newTicketState += 2
	elif (limitId == -4):
		newTicketState += 1
	if (oldTicketState != newTicketState):
		bf2.gameLogic.setTicketState(team, newTicketState)
		

def onFrigateTrigger(triggerId, cp, vehicle, enter, userData):

        if enter:
                text = str( vehicle.templateName )
                sTxt = text.split("_")
                if sTxt[0] == 'pl':
                        curPosition = vehicle.getPosition()
                        newHeight = curPosition[1] + 4 #Height to move player up
                        vehicle.setPosition( (curPosition[0], newHeight, curPosition[2]) )
                if sTxt[0] == 'ud':
                        curPosition = vehicle.getPosition()
                        newHeight = curPosition[1] + 4 #Height to move player up
                        vehicle.setPosition( (curPosition[0], newHeight, curPosition[2]) )
  
def onBrigTrigger(triggerId, cp, vehicle, enter, userData):

        if enter:
                text = str( vehicle.templateName )
                sTxt = text.split("_")
                if sTxt[0] == 'pl':
                        curPosition = vehicle.getPosition()
                        newHeight = curPosition[1] + 3 #Height to move player up
                        vehicle.setPosition( (curPosition[0], newHeight, curPosition[2]) )
                if sTxt[0] == 'ud':
                        curPosition = vehicle.getPosition()
                        newHeight = curPosition[1] + 3 #Height to move player up
                        vehicle.setPosition( (curPosition[0], newHeight, curPosition[2]) )
def onCutterTrigger(triggerId, cp, vehicle, enter, userData):

        if enter:
                text = str( vehicle.templateName )
                sTxt = text.split("_")
                if sTxt[0] == 'pl':
                        curPosition = vehicle.getPosition()
                        newHeight = curPosition[1] + 3 #Height to move player up
                        vehicle.setPosition( (curPosition[0], newHeight, curPosition[2]) )
                if sTxt[0] == 'ud':
                        curPosition = vehicle.getPosition()
                        newHeight = curPosition[1] + 3 #Height to move player up
                        vehicle.setPosition( (curPosition[0], newHeight, curPosition[2]) )

#Called when someone enters or exits cp radius
def onCPTrigger(triggerId, cp, vehicle, enter, userData):
        
        global g_controlPoints
        global g_ctfFlagstoWinee

        if g_bfp2gamemodetype == 0 or g_bfp2gamemodetype == 3:                  #Gametype is CQ or Armada
                if not cp.isValid(): return
                if vehicle and vehicle.getParent(): return
                if cp.cp_getParam('unableToChangeTeam') != 0:                   #Can this cp be captured at all?
                        return
                playersInVehicle = None
                if vehicle:
                        playersInVehicle = vehicle.getOccupyingPlayers()
                if enter:
                        for p in playersInVehicle:                              #Mark all vehicle occupants as in the CP radius
                                cp = getOccupyingCP(p)
                                if cp != None:
                                        if not p.getIsInsideCP():
                                                if g_debug: print "Resetting enterPctAt for player ", p.getName()
                                                p.enterCpAt = host.timer_getWallTime()
                if vehicle:
                        for p in playersInVehicle:
                                if p == playersInVehicle[0]:                    #Only count first player in a vehicle
                                        if g_debug: print p.index, " is in radius. v=", vehicle.templateName
                                        p.setIsInsideCP(enter)
                                else:
                                        if g_bfp2gamemodetype == 3:
                                                p.setIsInsideCP(enter)          #Count crew as inside capping radius for Armada mode
                                        else:   
                                                p.setIsInsideCP(0)
                                                if enter == 1:                  #For those spawning into a vehicle
                                                        bf2.gameLogic.sendHudEvent(p, 66, 49) #66 = HEEnableHelpMessage, 49 = VHMExitToCaptureFlag;
                #Count people in radius
                team1Occupants = 0
                team2Occupants = 0
                pcos = bf2.triggerManager.getObjects(cp.triggerId)
                for o in pcos:
                        if not o: continue                                      #You can get None in the result tuple when the host can't figure out what object left the trigger
                        if o.getParent(): continue                              #GetOccupyingPlayers returns all players downwards in the hierarchy, so dont count them twice
                        occupyingPlayers = o.getOccupyingPlayers()
                        for p in occupyingPlayers:
                                #Only count first player in a vehicle
                                #If p != occupyingPlayers[0]:
                                #       continue
                                if p.isAlive() and not p.isManDown():           #Count the number of players who are alive
                                        if not p.killed:
                                                if p.getTeam() == 1:
                                                        team1Occupants += 1
                                                elif p.getTeam() == 2:
                                                        team2Occupants += 1
                #Determine who is taking control
                team1OverWeight = team1Occupants - team2Occupants
                attackOverWeight = 0
                if team1OverWeight > 0:
                        attackingTeam = 1
                elif team1OverWeight < 0:
                        attackingTeam = 2
                else:
                        attackingTeam = 0
                if team1Occupants == 0 and team2Occupants == 0:
                        if cp.cp_getParam('team') == 0:                         #Nobody here, slowly go back to owning team
                                attackOverWeight = -0.5
                        else:
                                attackOverWeight = 0.5
                        timeToChangeControl = cp.cp_getParam('timeToLoseControl')
                else:                                                           #Raise flag if already ours, or at bottom and neutral. Otherwise lower first.
                        if cp.cp_getParam('flag') == attackingTeam or (cp.flagPosition == Bottom and cp.cp_getParam('team') == 0):
                                attackOverWeight = abs(team1OverWeight)         #Our flag, raise
                                timeToChangeControl = cp.cp_getParam('timeToGetControl')
                        else:
                                attackOverWeight = - abs(team1OverWeight)       #Other team raised flag, lower first
                                timeToChangeControl = cp.cp_getParam('timeToLoseControl')

                if cp.cp_getParam('onlyTakeableByTeam') != 0 and cp.cp_getParam('onlyTakeableByTeam') != attackingTeam:
                        return
                if cp.flagPosition == Bottom:                                   #Flag can only be changed when at bottom
                        cp.cp_setParam('flag', attackingTeam)
                if timeToChangeControl > 0:                                     #Calculate flag raising/lowering speed
                        takeOverChangePerSecond = 1.0 * attackOverWeight / timeToChangeControl
                else:
                        takeOverChangePerSecond = 0.0
                if (cp.flagPosition == Top and takeOverChangePerSecond > 0) or (cp.flagPosition == Bottom and takeOverChangePerSecond < 0):
                        takeOverChangePerSecond = 0.0
                if abs(takeOverChangePerSecond) > 0:
                        cp.flagPosition = Middle
                cp.cp_setParam('takeOverChangePerSecond', takeOverChangePerSecond)
        elif g_bfp2gamemodetype == 1:                                           #Gametype is CTF
                if not cp.isValid(): return
                if vehicle and vehicle.getParent(): return
                flagName = cp.templateName
                if not flagName in g_flag_names: return
                global g_flag_playerInx
                print "onCPTrigger() flagName: ", flagName, "g_flag_playerInx: ", g_flag_playerInx
                playerID = -1
                playerObj = None
                playersInVehicle = None
                if vehicle:
                        playersInVehicle = vehicle.getOccupyingPlayers()
                        for p in playersInVehicle:
                                GetDetails(p)
                                if not rootObjectname in g_soldier_types: return
                                if p == playersInVehicle[0]:                    #Only count first player in a vehicle
                                        playerObj = p
                                        playerID = playerObj.index
                if playerID != -1:
                        if playerObj != None:
                                if playerObj.isAlive() and not playerObj.isManDown():
                                        if not playerObj.killed:
                                                playersTeam = playerObj.getTeam()
                                                if playersTeam == cp.cp_getParam('team'):
                                                        #This is my team's flag pole
                                                        #make sure I have the flag
                                                        if g_flag_playerInx[ playersTeam ] == playerID:
                                                                #Only allow flag capture if other flag is not stolen
                                                                otherTeam = g_flag_otherTeam[ playersTeam ]
                                                                if g_flag_playerInx[ otherTeam ] == -1:
                                                                        # !! CAPTURED THE FLAG !!
                                                                        host.sgl_sendTextMessage(1, 13, 1,  "Yarr! " + str(playerObj.getName()) + " has captured the " + str( g_team_names[ otherTeam ] ) + " flag for us!", playersTeam )
                                                                        host.sgl_sendTextMessage(1, 13, 1,  "You scurvy ridden landlubbers, " + str(playerObj.getName()) + " has captured your flag!", otherTeam )
                                                                        resetFlagPos(playersTeam)
                                                                        g_flag_playerInx[ playersTeam ] = -1
                                                                        if playersTeam == 2:
                                                                                bf2.gameLogic.sendMedalEvent(playerObj, 1190601, 3) #Player has capt undead flag
                                                                                playCTFSound("u2",12)
                                                                        elif playersTeam == 1:
                                                                                bf2.gameLogic.sendMedalEvent(playerObj, 1191819, 3) #Player has capt pegleg flag
                                                                                playCTFSound("p2",2)
                                                                        #Give the player some points
                                                                        playerObj.score.cpCaptures += 1
                                                                        addScore(playerObj, 10, RPL)
                                                                        bf2.gameLogic.sendGameEvent(playerObj, 12, 0) #12,0 = Capture
                                                                        #Get current tickets and add 1
                                                                        teamTickets = bf2.gameLogic.getTickets( playersTeam )
                                                                        teamTickets += 1
                                                                        bf2.gameLogic.setTickets( playersTeam , teamTickets)
                                                                        if teamTickets >= 1000 + g_ctfFlagstoWin:
                                                                                #Team has won the round
                                                                                bf2.gameLogic.setTickets(2 , (bf2.gameLogic.getTickets(2) - 1000))
                                                                                bf2.gameLogic.setTickets(1 , (bf2.gameLogic.getTickets(1) - 1000))
                                                                                host.sgl_endGame(playersTeam, 3)
                                                                        else:
                                                                                prnt( "Capturing " + str( g_ctfFlagstoWin ) + " flags will win the round. The " + str( g_team_names[ playersTeam ] ) + " team need just " + str( g_ctfFlagstoWin - ( teamTickets - 1000 ) ) + " more to win!" )
                                                else:
                                                        playersTeam = playerObj.getTeam()
                                                        #See if flag has not yet been taken and its not my own flag pole and the flag poles team is not set to zero
                                                        otherTeam = g_flag_otherTeam[ playersTeam ]
                                                        if g_flag_playerInx[ playersTeam ] == -1 and playersTeam != cp.cp_getParam('team') and cp.cp_getParam('team') != 0:
                                                                #!! STOLE THE ENEMY FLAG !!
                                                                host.sgl_sendTextMessage(1, 13, 1,  str(playerObj.getName()) + " has stolen the " + str( g_team_names[ otherTeam ] ) + " flag!", playersTeam )
                                                                host.sgl_sendTextMessage(1, 13, 1,  str(playerObj.getName()) + " has stolen your flag! Get it back you Scurvy Dogs.", otherTeam )
                                                                g_flag_playerInx[ playersTeam ] = playerID
                                                                if playersTeam == 1:
                                                                        bf2.gameLogic.sendMedalEvent(playerObj, 1220118, 3) #Player has pegleg flag
                                                                        playCTFSound("p1",1)
                                                                elif playersTeam == 2:
                                                                        bf2.gameLogic.sendMedalEvent(playerObj, 1220104, 3) #Player has undead flag
                                                                        playCTFSound("u1",11)
                                                                #Give this dood some points
                                                                p.score.cpAssists += 1
                                                                addScore(p, 5, RPL)
                                                                bf2.gameLogic.sendGameEvent(p, 12, 2) #12,2 = Assist
                updateFlags()

#Called when a control point flag reached top or bottom
def onCPStatusChange(cp, top):

	if g_bfp2gamemodetype == 0 or g_bfp2gamemodetype == 3:                  #Gametype is CQ or Armada

		playerId = -1
		takeoverType = -1
		newTeam = -1
		scoringTeam = -1
			
		if top:	cp.flagPosition = Top
		else:   cp.flagPosition = Bottom
		#Determine capture / neutralize / defend
		if cp.cp_getParam('team') != 0:
			if top:
				#Automatically reset to captured
				pass
			else:
				#Player neutralised flag
				newTeam = 0
				if cp.cp_getParam('team') == 1:
					scoringTeam = 2
				else:
					scoringTeam = 1
				takeoverType = TAKEOVERTYPE_NEUTRALIZE
		else:
			if top:
				#Player captured flag
				newTeam = cp.cp_getParam('flag')
				scoringTeam = newTeam
				takeoverType = TAKEOVERTYPE_CAPTURE
			else:
				#Automatically reset to neutral
				pass
		#Scoring
		if takeoverType > 0:
			pcos = bf2.triggerManager.getObjects(cp.triggerId)
			#Count number of players
			scoringPlayers = []
			firstPlayers = []
			for o in pcos:
				if o.getParent(): continue
				occupyingPlayers = o.getOccupyingPlayers()
				for p in occupyingPlayers:
					#Only count first player in a vehicle
					#If p != occupyingPlayers[0]: 
					#	continue
					if p.isAlive() and not p.isManDown() and p.getTeam() == scoringTeam:
						if len(firstPlayers) == 0 or p.enterCpAt < firstPlayers[0].enterCpAt:
							firstPlayers = [p]
						elif p.enterCpAt == firstPlayers[0].enterCpAt:
							firstPlayers += [p]
						if not p in scoringPlayers:
							scoringPlayers += [p]
			#Deal score
			for p in scoringPlayers:
			        oldScore = p.score.score;
			        if takeoverType == TAKEOVERTYPE_CAPTURE:
			                if p in firstPlayers:
			                        p.score.cpCaptures += 1
			                        addScore(p, SCORE_CAPTURE, RPL)
			                        bf2.gameLogic.sendGameEvent(p, 12, 0) #12 = Conquest, 0 = Capture
			                        playerId = p.index
			                else:
			                        p.score.cpAssists += 1
			                        addScore(p, SCORE_CAPTUREASSIST, RPL)
			                        bf2.gameLogic.sendGameEvent(p, 12, 2) #12 = Conquest, 2 = Assist
			        elif takeoverType == TAKEOVERTYPE_NEUTRALIZE:
			                if p in firstPlayers:
			                        p.score.cpNeutralizes += 1
			                        addScore(p, SCORE_NEUTRALIZE, RPL)
			                        bf2.gameLogic.sendGameEvent(p, 12, 3) #12 = Conquest, 3 = Neutralize
			                else:
			                        p.score.cpNeutralizeAssists += 1
			                        addScore(p, SCORE_NEUTRALIZEASSIST, RPL)
			                        bf2.gameLogic.sendGameEvent(p, 12, 4) #12 = Conquest, 4 = Neutralize assist
		#Immediate ticket loss for opposite team
		enemyTicketLossInstant = cp.cp_getParam('enemyTicketLossWhenCaptured')
		if enemyTicketLossInstant > 0 and newTeam > 0:
			if newTeam == 1:
				punishedTeam = 2
			elif newTeam == 2:
				punishedTeam = 1
			tickets = bf2.gameLogic.getTickets(punishedTeam)
			tickets -= enemyTicketLossInstant
			bf2.gameLogic.setTickets(punishedTeam, tickets)
		#Update control point	
		cp.cp_setParam('playerId', playerId) #Always set player first
		if newTeam != -1 and cp.cp_getParam('team') != newTeam:
			cp.cp_setParam('team', newTeam)
		onCPTrigger(cp.triggerId, cp, 0, 0, 0)
		if g_bfp2gamemodetype == 0:
			updateTicketLoss()                                              #Check for a new ticket bleed in Conquest
	
def onPlayerDeath(victim, vehicle):

        global g_zombiePlayers
        if victim.isTker == True:
                victim.setTimeToSpawn(30)
        else:
                victim.setTimeToSpawn( int(host.rcon_invoke("sv.spawnTime")) )
        if g_bfp2gamemodetype == 0:                                             #Gametype = CQ
                if victim != None:
                        team = victim.getTeam()
                        teamTickets = bf2.gameLogic.getTickets(team)
                        teamTickets -= 1
                        bf2.gameLogic.setTickets(team, teamTickets)
                #Check if it was the last player
                foundLivingPlayer = False
                for p in bf2.playerManager.getPlayers():
                        if p != victim and p.getTeam() == victim.getTeam() and p.isAlive():
                                foundLivingPlayer = True
                if not foundLivingPlayer:
                       updateTicketLoss()
        elif g_bfp2gamemodetype == 1:                                                   #Gametype = CTF
                if not victim:
                        return
                playerDropFlag(victim)
                updateFlags()
        elif g_bfp2gamemodetype == 2:                                                   #Gametype = ZM
                if not victim:
                        return
                #Check if game has started
                if g_bfp2gamestate == 2:
                        team = victim.getTeam()
                        if team == 1:                                                   #Player is zombie team
                                victim.iszombie = True                                  #Now set player to zombie
                        zm_settickets()
        elif g_bfp2gamemodetype == 3:                                                   #Gametype = ARM
                if victim != None:
                        team = victim.getTeam()
                        teamTickets = bf2.gameLogic.getTickets(team)
                        teamTickets -= 1
                        bf2.gameLogic.setTickets(team, teamTickets)
                        victim.isInRange = False
                #Check if it was the last player
                foundLivingPlayer = False
                for p in bf2.playerManager.getPlayers():
                        if p != victim and p.getTeam() == victim.getTeam() and p.isAlive():
                                foundLivingPlayer = True
                if not foundLivingPlayer:
                       updateTicketLoss()

def onPlayerDisconnect(player):
        
        global g_zombiePlayers
        
        if g_bfp2gamemodetype == 1:                                                     #Gametype = CTF
                playerDropFlag(player)
                updateFlags()
        if g_bfp2gamemodetype == 2:                                                     #Gametype = ZM
                if g_zombie_Started == 2:                                               #Round is started
                        zm_settickets()	

def onPlayerConnect(player):
        
        global g_zombiePlayers
        
        if g_bfp2gamemodetype == 2:
        	if g_bfp2gamestate != 0:                                                #Round started
        		if g_zombiePlayers[1] <= g_zombiePlayers[2]:                    #Num of Undead less than num of Peglegs
        			timer.once(0.01, onConnectTeamChange, player, 2)
        		else:
        			timer.once(0.01, onConnectTeamChange, player, 1)
        else:
                #Even teams as they may be uneven after zombie round
                team1 = bf2.playerManager.getNumberOfPlayersInTeam(1)
                team2 = bf2.playerManager.getNumberOfPlayersInTeam(2)
                if team1 <= team2:                                                      #Num of Undead less than num of Peglegs
                        timer.once(0.01, onConnectTeamChange, player, 1)
                else:
                	timer.once(0.01, onConnectTeamChange, player, 2)
        
        if player.stats.profileId != 0:
                playerData = get_rank(player.stats.profileId)
                #bf2.gameLogic.sendRankEvent(player, int(playerData.split(":")[0]), 0)
                player.stats.rank = int(playerData.split(":")[0])

def onConnectTeamChange(player, team):
        
        player.setTeam(team)
                
def onPlayerKilled(victim, attacker, weapon, assists, object):

        global g_zombiePlayers
        
        if not victim:
                return
        
        if g_bfp2gamemodetype == 0  or g_bfp2gamemodetype == 3:                         #Gametype = CQ or armada
                victim.killed = True
                #Update flag takeover status if victim was in a CP radius
                cp = getOccupyingCP(victim)
                if cp != None:
                        onCPTrigger(-1, cp, victim.getVehicle(), False, None)
                        #Give defend score if killing enemy within cp radius
                        if attacker != None and attacker.getTeam() != victim.getTeam() and cp.cp_getParam('unableToChangeTeam') == 0 and cp.cp_getParam('onlyTakeableByTeam') == 0:
                                if cp != None and cp.cp_getParam('team') == attacker.getTeam():
                                        attacker.score.cpDefends += 1
                                        addScore(attacker, SCORE_DEFEND, RPL)
                                        bf2.gameLogic.sendGameEvent(attacker, 12, 1) #12 = Conquest, 1 = Defend
        elif g_bfp2gamemodetype == 1: #Gametype = CTF
                victim.killed = True
                playerDropFlag(victim)
                updateFlags()
        elif g_bfp2gamemodetype == 2: #Gametype = ZM
                team = victim.getTeam()
                ateam = attacker.getTeam()
                
                attacker.isTker = False
                victim.isTker = False
                
                #Check if game has started
                if g_bfp2gamestate == 2:
                        victim.killed = True
                        
                        #check if suicide
                        if attacker == None:
                                victim.setTeam(1)
                                bf2.gameLogic.sendMedalEvent(victim, 1222016, 3) #victim has become a zombie
                                host.sgl_sendTextMessage(1, 13, 1, victim.getName() + " is now a zombie, run for ya lives!!!", 2 ) #Notice to PL
                                host.sgl_sendTextMessage(1, 13, 1, victim.getName() + " has joined the ranks of living dead", 1 ) #Notice to UD
                                zm_settickets()
                        else:
                                if team == 2: #victim is pegleg
                                        if ateam == 1: #Attacker is zombie
                                                victim.setTeam(1)
                                                bf2.gameLogic.sendMedalEvent(victim, 1222016, 3) #victim has become a zombie
                                                host.sgl_sendTextMessage(1, 13, 1, victim.getName() + " is now a zombie, run for ya lives!!!", 2 ) #Notice to PL
                                                host.sgl_sendTextMessage(1, 13, 1, victim.getName() + " has joined the ranks of living dead", 1 ) #Notice to UD
                                                #Give attacker points
                                                attacker.score.cpCaptures += 1
                                                #addScore(attacker, g_zombiePlayers[1]-2, SKILL)
                                                zm_settickets()
                                        elif ateam == 2 and victim != attacker: #Attacker is pegleg - teamkilled
                                                if attacker.isAlive():
                                                        vehicle = attacker.getVehicle()
                                                        rootVehicle = getRootParent(vehicle)
                                                        if getVehicleType(rootVehicle.templateName) == VEHICLE_TYPE_SOLDIER:
                                                                rootVehicle.setDamage(.1)
                                                        else:
                                                                rootVehicle.setDamage(1)
                                                host.sgl_sendTextMessage(1, 13, 1, attacker.getName() + " has been penalised for teamkilling", 2 ) #Notice to PL
                                                host.sgl_sendTextMessage(1, 13, 1, attacker.getName() + " has been penalised for teamkilling", 1 ) #Notice to UD
                                                attacker.isTker = True
                                                #Remove tkers points
                                                #attacker.score.TKs += 1
                                                #addScore(attacker, -4, RPL)
                                elif team == 1: #victim is undead
                                        if ateam == 1 and victim != attacker: #Attacker is undead - teamkilled
                                                host.sgl_sendTextMessage(1, 13, 1, attacker.getName() + " has been penalised for teamkilling", 2 ) #Notice to PL
                                                host.sgl_sendTextMessage(1, 13, 1, attacker.getName() + " has been penalised for teamkilling", 1 ) #Notice to UD
                                                attacker.isTker = True
                                                #Remove tkers points
                                                #attacker.score.TKs += 1
                                                #addScore(attacker, -4, RPL)
                                        elif ateam == 2: #Attacker is pegleg
                                                #Give attacker points
                                                attacker.score.cpAssists += 1
                                                #addScore(attacker, g_zombiePlayers[2]-2, SKILL)
                        
        if g_bfp2gamemodetype == 3:                                                   #Gametype = ARM
                victim.isInRange = False


def onPlayerSpawn(player, soldier):
                
        player.killed = False
        player.isTker = False
        if g_bfp2gamemodetype == 1:                             #Gametype = CTF
                if g_ctfFlagsPositioned == 0:
                        getResetFlagLocation()
        if g_bfp2gamemodetype == 2:                             #Gametype = Zombie
                if g_bfp2gamestate == 0:                        #Round not started
                        zm_clean()
        if g_bfp2gamemodetype == 3:                             #Gametype = Armada
                if g_armadaNumPoints == 0:
                        #prnt("DEBUG - No Armada flags, getting locations")
                        arm_GetLocations()
                player.isInRange = False
        
        print host.rcon_invoke("gamelogic.supplyDropNumSecsToLive " + str(g_bfp2gamemodetype))
        print host.rcon_invoke("gamelogic.supplyDropHeight " + str(g_bfp2gamestate))

def onEnterVehicle(player, vehicle, freeSoldier = False):
	
	global g_bfp2gamemodetype	

	if g_bfp2gamemodetype == 0 or g_bfp2gamemodetype == 3: #Gametype = CQ or Armada
		player.setIsInsideCP(False)
		cp = getOccupyingCP(player)
		if cp != None:
			onCPTrigger(-1, cp, vehicle, False, None)
			updateCaptureStatus(vehicle) 
	else:                                                   #Gametype = CTF or Zombie
		updateCaptureStatus(vehicle)

def onExitVehicle(player, vehicle):

        if g_bfp2gamemodetype == 0 or g_bfp2gamemodetype == 3: #Gametype = CQ or armada
        
                #Update flag takeover status if player in a CP radius
                if g_debug: print "Player exiting ", player.getName()
                cp = getOccupyingCP(player)
                #Can this cp be captured at all?
                player.setIsInsideCP(cp != None and cp.cp_getParam('unableToChangeTeam') == 0)
                updateCaptureStatus(vehicle)	

#Update cp capture status on players in vehicle
def updateCaptureStatus(vehicle):	

	rootVehicle = bf2.objectManager.getRootParent(vehicle)
	playersInVehicle = rootVehicle.getOccupyingPlayers()
	#Set the player in the topmost pco as inside - others outside
	for p in playersInVehicle:
		if g_debug: print "Players in vehicle ", p.getName()
		cp = getOccupyingCP(p)
		p.setIsInsideCP(cp != None and cp.cp_getParam('unableToChangeTeam') == 0 and p == playersInVehicle[0])

#Find cp that player is occupying, if any		
def getOccupyingCP(player):
	vehicle = player.getVehicle()
	playerPos = vehicle.getPosition()
	
	#Find closest CP
	closestCP = None
	if len(g_controlPoints) == 0: return None
	for obj in g_controlPoints:
		distanceTo = getVectorDistance(playerPos, obj.getPosition())
		if closestCP == None or distanceTo < closestCPdist:
			closestCP = obj
			closestCPdist = distanceTo
	#Is the player in radius?
	pcos = bf2.triggerManager.getObjects(closestCP.triggerId)
	for o in pcos:
		if o == player.getDefaultVehicle():
			#Player is DEFAULT vehicle - this is needed when called from onEnterVehicle
			return closestCP
		else:
			for p in o.getOccupyingPlayers():
				if p == player:
					return closestCP
	return None

#Get distance between two positions
def getVectorDistance(pos1, pos2):
	diffVec = [0.0, 0.0, 0.0]
	diffVec[0] = math.fabs(pos1[0] - pos2[0])
	diffVec[1] = math.fabs(pos1[1] - pos2[1])
	diffVec[2] = math.fabs(pos1[2] - pos2[2])
	 
	return math.sqrt(diffVec[0] * diffVec[0] + diffVec[1] * diffVec[1] + diffVec[2] * diffVec[2])

#
#DEFENITIONS for CTF Gamemode
#

def getResetFlagLocation():
        
        global g_ctfFlagPos
        
        g_PlayerControlObjects = bf2.objectManager.getObjectsOfType('dice.hfe.world.ObjectTemplate.PlayerControlObject')
        for pcoObj in g_PlayerControlObjects:
                if pcoObj.templateName == "ctfDummyObject":
                        g_ctfFlagPos = pcoObj.getPosition()

def FindDetails(physicalObject,level):
#Get details for the flags
                global CarryFlagCP_Object
                global rootObjectname
                resultString = physicalObject.templateName
                if resultString == "CarryFlagCP":
                        CarryFlagCP_Object = physicalObject
                if level == 0:
                        rootObjectname=resultString
                kids = physicalObject.getChildren()
                for child in kids:
                        FindDetails(child,level + 1)

def GetDetails(p):
        CarryFlagCP_Object = None
        rootObjectname = ""
        physicalObject = bf2.objectManager.getRootParent(p.getVehicle())
        FindDetails(physicalObject,0)	

def playerDropFlag(player):
        global g_flag_playerInx
        global g_timeDroppedFlag
        #See if the player was carrying a flag
        for i in [1,2]:
                otherTeam = g_flag_otherTeam[i]
                if player.index == g_flag_playerInx[i]:
                        host.sgl_sendTextMessage(1, 13, 1, "Bloody Hell, " + str(player.getName()) + " has dropped the " + str( g_team_names[ otherTeam ] ) + " flag. Go get it quick!", player.getTeam() )
                        host.sgl_sendTextMessage(1, 13, 1, "Ha ha, " + str(player.getName()) + " has dropped our flag. Get it back you landlubbers!", otherTeam )
                        resetFlagPos(i)
                        g_flag_playerInx[i] = -2
                        DropTheFlag(player,i)
                        g_timeDroppedFlag[g_flag_otherTeam[i]] = host.timer_getWallTime()
                        playersTeam = player.getTeam()
                        if playersTeam == 1:
                                playCTFSound("p3",3)
                        elif playersTeam == 2:
                                playCTFSound("u3",13)

def DropTheFlag(player,flagID):
        vehicle = player.getVehicle()
        playerPos = vehicle.getPosition()
        g_PlayerControlObjects = bf2.objectManager.getObjectsOfType('dice.hfe.world.ObjectTemplate.PlayerControlObject')
        for obj in g_PlayerControlObjects:
                if flagID == 1:
                        if obj.templateName == "BlueMiniMapFlag":
                                children = obj.getChildren()
                                obj.setPosition(playerPos)
                                for child in children: 
                                        if child.templateName == "BlueDropFlagCP":
                                                #Now set the Red flag trigger and visibility
                                                id = bf2.triggerManager.createHemiSphericalTrigger(child, onCPPickupTrigger, '<<PCO>>', 3, (1, 2, 3))
                                                child.triggerId = id
                if flagID == 2:
                        if obj.templateName == "RedMiniMapFlag":
                                children = obj.getChildren()
                                obj.setPosition(playerPos)
                                for child in children: 
                                        if child.templateName == "RedDropFlagCP":
                                                #Now set the Red flag trigger and visibility
                                                id = bf2.triggerManager.createHemiSphericalTrigger(child, onCPPickupTrigger, '<<PCO>>', 3, (1, 2, 3))
                                                child.triggerId = id

#Called when someone enters a dropped flags radius
def onCPPickupTrigger(triggerId, cp, vehicle, enter, userData):
        global tp
        global g_timeDroppedFlag
        global g_flag_playerInx
        if not cp.isValid(): return
        if enter:
                for p in vehicle.getOccupyingPlayers():
                        GetDetails(p)
                        otherTeam = g_flag_otherTeam[ p.getTeam() ]
                        
                        if p.isAlive() and not p.isManDown():
                                if not p.killed:
                                        if rootObjectname in g_soldier_types:
                                                if (cp.templateName == "BlueDropFlagCP" and  p.getTeam() == 2):
                                                        host.trig_destroy(triggerId)
                                                        host.sgl_sendTextMessage(1, 13, 1, "At least " + str(p.getName()) + " isn't a landlubber, they've rescued your flag!", p.getTeam() )
                                                        host.sgl_sendTextMessage(1, 13, 1, "You landlubbers, " + str(p.getName()) + " has resuced the " + str( g_team_names[ p.getTeam() ] ) + " flag!", otherTeam )
                                                        g_flag_playerInx[1] = -1
                                                        HideBlueMiniMapFlag()
                                                        g_timeDroppedFlag[2]=-1
                                                        playCTFSound("p4",4)
                                                        bf2.gameLogic.sendMedalEvent(p, 1220803, 3) #Player has returned pegleg flag
                                                        p.score.cpDefends += 1
                                                        addScore(p, 5, RPL)
                                                        bf2.gameLogic.sendGameEvent(p, 12, 1)   #12,1 = Defend Flag
                                                elif (cp.templateName == "RedDropFlagCP" and  p.getTeam() == 1):
                                                        host.trig_destroy(triggerId)
                                                        host.sgl_sendTextMessage(1, 13, 1, "At least " + str(p.getName()) + " isn't a landlubber, they've rescued your flag!", p.getTeam() )
                                                        host.sgl_sendTextMessage(1, 13, 1, "You landlubbers, " + str(p.getName()) + " has resuced the " + str( g_team_names[ p.getTeam() ] ) + " flag!", otherTeam )
                                                        g_flag_playerInx[2] = -1
                                                        HideRedMiniMapFlag()
                                                        g_timeDroppedFlag[1]=-1
                                                        playCTFSound("u4",14)
                                                        bf2.gameLogic.sendMedalEvent(p, 1220122, 3) #Player has returned undead flag
                                                        p.score.cpDefends += 1
                                                        addScore(p, 5, RPL)
                                                        bf2.gameLogic.sendGameEvent(p, 12, 1)   #12,1 = Defend Flag
                                                elif (cp.templateName == "BlueDropFlagCP" and  p.getTeam() == 1):
                                                        host.trig_destroy(triggerId)
                                                        host.sgl_sendTextMessage(1, 13, 1, str(p.getName()) + " has picked up the " + str( g_team_names[ otherTeam ] ) + " flag for us!", p.getTeam() )
                                                        host.sgl_sendTextMessage(1, 13, 1, "Come on you scurvy dogs, " + str(p.getName()) + " has picked up your flag!", otherTeam )
                                                        g_flag_playerInx[1] = p.index
                                                        HideBlueMiniMapFlag()
                                                        g_timeDroppedFlag[2]=-1
                                                        playCTFSound("p1",1)
                                                        bf2.gameLogic.sendMedalEvent(p, 1220118, 3) #Player has pegleg flag
                                                        p.score.cpAssists += 1
                                                        addScore(p, 5, RPL)
                                                        bf2.gameLogic.sendGameEvent(p, 12, 2)   #12,2 = Assist
                                                elif (cp.templateName == "RedDropFlagCP" and  p.getTeam() == 2):
                                                        host.trig_destroy(triggerId)
                                                        host.sgl_sendTextMessage(1, 13, 1, str(p.getName()) + " has picked up the " + str( g_team_names[ otherTeam ] ) + " flag for us!", p.getTeam() )
                                                        host.sgl_sendTextMessage(1, 13, 1, "Come on you scurvy dogs, " + str(p.getName()) + " has picked up your flag!", otherTeam )
                                                        g_flag_playerInx[2] = p.index
                                                        HideRedMiniMapFlag()
                                                        g_timeDroppedFlag[1]=-1
                                                        playCTFSound("u1",11)
                                                        bf2.gameLogic.sendMedalEvent(p, 1220104, 3)    #Player has undead flag
                                                        p.score.cpAssists += 1
                                                        addScore(p, 5, RPL)
                                                        bf2.gameLogic.sendGameEvent(p, 12, 2)   #12,2 = Assist
                                                #Give this dood some points
                                                addScore(p, 5, RPL)

def resetDroppedFlagonTime(FlagID):
                        if FlagID == 2:
                                prnt( "The Pegleg flag has been returned" )
                                playCTFSound("p4",4)
                                g_flag_playerInx[1] = -1
                                HideBlueMiniMapFlag()
                        elif FlagID == 1:
                                prnt( "The Undead flag has been returned" )
                                playCTFSound("u4",14)
                                g_flag_playerInx[2] = -1
                                HideRedMiniMapFlag()

def HideBlueMiniMapFlag():
        g_PlayerControlObjects = bf2.objectManager.getObjectsOfType('dice.hfe.world.ObjectTemplate.PlayerControlObject')
        for obj in g_PlayerControlObjects:
                        if obj.templateName == "BlueMiniMapFlag":
                                obj.setPosition(g_ctfFlagPos)
                                children = obj.getChildren()

def HideRedMiniMapFlag():
        g_PlayerControlObjects = bf2.objectManager.getObjectsOfType('dice.hfe.world.ObjectTemplate.PlayerControlObject')
        for obj in g_PlayerControlObjects:
                        if obj.templateName == "RedMiniMapFlag":
                                obj.setPosition(g_ctfFlagPos)
                                children = obj.getChildren()


def checkforsanity():
#Check to make sure that only the player with the flag on his team can have a VISIBLE FLAG
        for i in [1,2]:                                                         #Check team 1 and 2
                if g_flag_playerInx[i] >= 0:                                    #This team has the flag
                        for p in bf2.playerManager.getPlayers():                #Check eack player
                                if p.getTeam() == i:                            #On this team
                                        if p.index != g_flag_playerInx[i]:      #Who does not have the flag
                                                GetDetails(p)
                                                if CarryFlagCP_Object != None:
                                                        CarryFlagCP_Object.cp_setParam('flag',0)#make sure he doesnt have the visible flag showing
                                        elif p.index == g_flag_playerInx[i]:    #Who does have the flag
                                                GetDetails(p)
                                                if CarryFlagCP_Object != None:
                                                        CarryFlagCP_Object.cp_setParam('flag',g_flag_otherTeam[i])#make sure he does have the visible flag showing
#TODO do we need to add "and CarryFlagCP_Object.isValid():" everywhere?
#And make sure if no one has the flag they do not display the VISIBLE FLAG
                elif g_flag_playerInx[i] < 0: #This team does not have the flag
                        for p in bf2.playerManager.getPlayers():                #Check eack player
                                if p.getTeam() == i:                            #On this team
                                                GetDetails(p)
                                                if CarryFlagCP_Object != None and CarryFlagCP_Object.isValid():
                                                        CarryFlagCP_Object.cp_setParam('flag',0)        #Has no visible flag showing
#Now we are going to make sure that the base flags can not have the same teams 
        teamone = -1 
        teamtwo = -2 
        for obj in g_controlPoints:
                if obj.templateName in g_flag_names:
                        if obj.templateName == g_flag_names[1]:
                                teamone = obj.cp_getParam('team')
                        if obj.templateName == g_flag_names[2]:
                                teamtwo = obj.cp_getParam('team') 
        if teamone == teamtwo and teamone != 0: 
                prnt("RESET THE GAME - REPORT THIS TO DEVELOPERS - SHOULD NEVER NEVER HAPPEN!!!!") 
                resetctf()

def resetctf():
        global g_flag_playerInx
        global g_timeDroppedFlag
        global rootObjectname
        g_flag_playerInx = [-1,-1,-1]                           #Reset carried flags 
        g_timeDroppedFlag = [-1,-1,-1]                          #Reset dropped flags 
        rootObjectname = ""                                     #Reset global variables 

        for obj in g_controlPoints:
                if obj.templateName in g_flag_names:            #This is a base
                        if obj.templateName == g_flag_names[1]: #So reset the flags
                                obj.cp_setParam('flag', 1)
                                obj.cp_setParam('team', 1)
                        if obj.templateName == g_flag_names[2]: #So reset the flags
                                obj.cp_setParam('flag', 2)
                                obj.cp_setParam('team', 2)

def moveFlag(teamID,Pos):
        
        g_PlayerControlObjects = bf2.objectManager.getObjectsOfType('dice.hfe.world.ObjectTemplate.PlayerControlObject')

        for obj in g_PlayerControlObjects:
                if obj.templateName == g_carryFlagNames[teamID]:
                        #Print "  flag moved!"
                        obj.setPosition(Pos)

def showFlag(teamID,Pos,hideflag):                              #Flag display implementation

        player = bf2.playerManager.getPlayerByIndex(g_flag_playerInx[teamID])
        
        if player != None:
                g_PlayerControlObjects = bf2.objectManager.getObjectsOfType('dice.hfe.world.ObjectTemplate.PlayerControlObject')
                for obj in g_PlayerControlObjects:
                        if hideflag == 0 and obj.templateName == g_miniMapFlagNames[teamID]:
                                obj.setPosition(Pos)
                GetDetails(player)
                if hideflag == 1:
                	CarryFlagCP_Object.cp_setParam('flag',0)

def resetFlagPos(flagID):

        showFlag(flagID,g_ctfFlagPos,1)


    
def updateFlags():

        i = 0
        global g_timeDroppedFlag
        
        for obj in g_controlPoints:
                i += 1
                if obj.templateName in g_flag_names:
                        if obj.templateName == g_flag_names[1]:
                                team = 1
                        if obj.templateName == g_flag_names[2]:
                                team = 2
                        otherTeam = g_flag_otherTeam[team]
                        #Other team does not have this flag
                        if g_flag_playerInx[otherTeam] != -1:
                                if obj.cp_getParam('flag') != 0:
                                        obj.cp_setParam('flag', 0)
                        else:
                                if obj.cp_getParam('flag') != team:
                                        obj.cp_setParam('flag', team)
                                        if team == 1:
                                                HideRedMiniMapFlag()
                                        if team == 2:
                                                HideBlueMiniMapFlag()
        for i in [1,2]:
                if g_timeDroppedFlag[i] != -1 and ((host.timer_getWallTime() - g_timeDroppedFlag[i]) >= g_timeForDroppedFlagsToReturn):
                	resetDroppedFlagonTime(i)
                	g_timeDroppedFlag[i] = -1
                if g_flag_playerInx[i] == -1:
                        resetFlagPos(i)                                         #Flag is on pole
                else:
                        #Player is carrying the flag
                        player = bf2.playerManager.getPlayerByIndex(g_flag_playerInx[i])
                        if player != None:
                                vehicle = player.getVehicle()
                                playerPos = vehicle.getPosition()
                                X = playerPos[0]
                                Y = playerPos[1]+100.0
                                Z = playerPos[2]
                                showFlag(i,(X,Y,Z),0)

#
#DEFENITIONS for ZOMBIE Gamemode
#

def onPlayerChangeTeams(p, humanHasSpawned):
	
	if g_bfp2gamemodetype == 2:                                             #Gametype = ZM
		alive = p.isAlive()		
		if p.iszombie == True and alive != True:
			p.setTeam(1)
			prnt(str( p.getName() ) + " please do not attempt to switch teams or ya'll walk the plank!")
		else:
			if p.iszombie != True:
				p.iszombie = True
				prnt(str( p.getName() ) + " is a yellow belly coward!")    

def zm_reset(self, ctx, cmd):
	
	if g_bfp2gamemodetype == 2:                                             #Gametype = ZM
		zm_clean()
		ctx.write("Zombies reset\n")

def zm_accident(self, ctx, cmd):
        #prnt("Death by accident")
        if g_bfp2gamemodetype == 2:                                             #Gametype = ZM
        	for p in bf2.playerManager.getPlayers():
        		if p.getName() == cmd:
        			if p.getTeam() == 2:
        				p.iszombie = True
        				p.setTeam(1)
        				zm_settickets()
        			else:
        				ctx.write("Non zombies only!\n")
        				ctx.write("Player killed\n")
        		else:
        			ctx.write("No player found matching that name\n")	

def zm_shuffleup():
        
        global g_bfp2gamestate
        global g_zombieTimer
        global g_zombiePlayers
        
        g_zombieTimer = -1
        g_zombiePlayers[0] = 0
               
        p = bf2.playerManager.getPlayers()
        index = len(p)
        zombiePlayerIndex = random.randint(-1, index-1)
        zplayer = p[zombiePlayerIndex]
        zplayer.setTeam(1)
        zplayer.iszombie = True
        bf2.gameLogic.sendMedalEvent(zplayer, 1222016, 3)  #Player has become zombie
        
        if zplayer.isAlive():
                zplayer.getDefaultVehicle().setDamage(.01)              #Kill zombie
                #Prnt("Zombie Player has been killed")
        
        g_bfp2gamestate = 2
        
        for p in bf2.playerManager.getPlayers():
                if p.iszombie == False:
                        p.setTeam(2)
                        if p.isAlive():
                                p.getDefaultVehicle().setDamage(.01)    #Kill all players
        
        host.sgl_sendTextMessage(1, 13, 1, zplayer.getName() + " is now the zombie, run for ya lives!!!", 2 )   #Notice to PL
        host.sgl_sendTextMessage(1, 13, 1, zplayer.getName() + " you are now the Zombie!!!", 1 )      #Notice to UD
        print host.rcon_invoke("gamelogic.supplyDropHeight " + str(g_bfp2gamestate))

def zm_clean():
        
        global g_bfp2gamestate
        global g_zombieTimer
        
        if g_bfp2gamestate == 0:                                        #Check if round has not started  
        	for p in bf2.playerManager.getPlayers():
        		p.iszombie = False
        	pnum = bf2.playerManager.getPlayers()
        	index = len(pnum)
        	if index > 1:                                           #Then start round
        	        g_bfp2gamestate = 1
        	        print host.rcon_invoke("gamelogic.supplyDropHeight " + str(g_bfp2gamestate))
        	        g_zombieTimer = 62

def zm_settickets():
        
        global g_zombiePlayers
        
        g_zombiePlayers[1] = 0
        g_zombiePlayers[2] = 0
        
        if g_bfp2gamestate == 2:
                for p in bf2.playerManager.getPlayers():
                        g_zombiePlayers[ p.getTeam() ] += 1
                        
                if g_zombiePlayers[1] < 1:                              #For some reason we have no zombies - add one
                        players = bf2.playerManager.getPlayers()
                        index = len(players)
                        zombiePlayerIndex = random.randint(-1, index-1)
                        zplayer = players[zombiePlayerIndex]
                        zplayer.setTeam(1)
                        zplayer.iszombie = True
                        bf2.gameLogic.sendMedalEvent(zplayer, 1222016, 3)      #Player has become zombie
                        if zplayer.isAlive():
                                zplayer.getDefaultVehicle().setDamage(.01) #Kill zombie
                        host.sgl_sendTextMessage(1, 13, 1, zplayer.getName() + " is now the zombie, run for ya lives!!!", 2 )   #Notice to PL
                        host.sgl_sendTextMessage(1, 13, 1, zplayer.getName() + " has joined the ranks of living dead", 1 )      #Notice to UD
                        g_zombiePlayers[1] += 1
                        g_zombiePlayers[2] -= 1
                
                if g_zombiePlayers[2] == 1:                             #Notify players who the last Pegleg is
                        if g_zombiePlayers[0] != -1:
                                for p in bf2.playerManager.getPlayers():
                                        if p.getTeam() == 2:
                                                #playZMSound(lp)
                                                emphprnt(str( p.getName() ) + " is the last surviving Pegleg!")
                                                bf2.gameLogic.sendMedalEvent(p, 1190507, 3) #victim has become a zombie
                                                g_zombiePlayers[0] = -1
                                                break
                
                if g_zombiePlayers[2] < 1:                              #No peglegs left, zombies win
                        timer.once(3, delay_gameover, 1, 3)
                else:
                        bf2.gameLogic.setTickets(1, g_zombiePlayers[1])
                        bf2.gameLogic.setTickets(2, g_zombiePlayers[2])
                
        if g_bfp2gamestate == 0:
                zm_clean()

#
#DEFENITIONS for ARMADA Gamemode
#

def arm_RandomFlagPos():
              
        new_armPoint = random.randint(-1, g_armadaNumPoints - 2)                # Get new Random Point
        
        if new_armPoint == -1:
                new_armPoint = 0
        
        if new_armPoint == g_armadaCurPoint:                                    # Check if random point is the same as current point
                new_armPoint = g_armadaNumPoints-1                              # Send to the last resort (literally!)
        
        arm_SetFlagPos(new_armPoint)                                            # Set flag pos to new Random Flag

def arm_SetFlagPos(newPoint):
        
        global g_armadaCurPoint
        global g_bfp2gamestate
        
        try:
                
                g_armadaCurPoint = newPoint                                             # Set newPoint to currentPoint
                
                delete_object("armadaindicator","0")
                
                prnt( "The battle is to be fought elsewhere. Move you landlubbers!")    # Notify the players
                
                create_object("armadaindicator","1",g_armadaPointsX[g_armadaCurPoint],g_armadaPointsY[g_armadaCurPoint]-11,g_armadaPointsZ[g_armadaCurPoint],"0.00","0.00","0.00")
                
                arm_RemoveTriggerAtt()                                                  # Clear Trigger Lists
                
                bf2.gameLogic.setTicketState(1, 0)
                bf2.gameLogic.setTicketState(2, 0)
                
                for acp in g_controlPoints:
                        
                        if acp.templateName == "ArmadaFlag":
                                acp.triggerId = g_armadaIdPoints[g_armadaCurPoint]
                
                g_bfp2gamestate = 1
                print host.rcon_invoke("gamelogic.supplyDropHeight " + str(g_bfp2gamestate))
        except:
                if g_debug: debug.exception()
        
def arm_GetLocations():
        
        global g_armadaPointsX
        global g_armadaPointsY
        global g_armadaPointsZ
        global g_armadaNumPoints
        global g_armadaIdPoints

        point_num = 0
        g_PlayerControlObjects = bf2.objectManager.getObjectsOfType('dice.hfe.world.ObjectTemplate.PlayerControlObject')
        for pcoObj in g_PlayerControlObjects:
                if pcoObj.templateName == "armadaDummyObject":
                        if str( pcoObj.getPosition() ) != "(0.0, 0.0, 0.0)":
                                thisPos = pcoObj.getPosition()
                                g_armadaPointsX[point_num] = thisPos[0]
                                g_armadaPointsY[point_num] = thisPos[1]
                                g_armadaPointsZ[point_num] = thisPos[2]
                                #Add trigger radius to dummyobject
                                id = bf2.triggerManager.createRadiusTrigger(pcoObj, arm_onArmTrigger, '<<PCO>>', 100.0, (1, 2, 3))
                                #store id
                                g_armadaIdPoints[point_num] = id
                                point_num += 1
        g_armadaNumPoints = point_num
        
        arm_SetFlagPos(0)

def arm_RemoveTriggerAtt():
        
        # Clear Trigger Lists
        
        global g_armadaPlayerCount
        
        for player in bf2.playerManager.getPlayers():
                player.isInRange = False
        
        g_armadaPlayerCount = [0,0,0]
        
def arm_battlewon(winTeam):
        
        global g_bfp2gamestate
        
        g_bfp2gamestate = 0
        print host.rcon_invoke("gamelogic.supplyDropHeight " + str(g_bfp2gamestate))
        arm_RemoveTriggerAtt()
        
        # A battle has been won - distribute points etc and reset flag pos
        # Distribute CP points
        for player in bf2.playerManager.getPlayers():
                if hasattr(player, 'isInRange'):
                           if player.isInRange == True:
                                if player.getTeam() == winTeam:
                                        player.score.cpCaptures += 1
                                        addScore(player, 5, RPL)
        if winTeam == 1:
                emphprnt("The Undead have won this battle!")
                oldTickets = bf2.gameLogic.getTickets(2)
                bf2.gameLogic.setTickets(2, oldTickets - 25)
        if winTeam == 2:
                emphprnt("The Peglegs have won this battle!")
                oldTickets = bf2.gameLogic.getTickets(1)
                bf2.gameLogic.setTickets(1, oldTickets - 25)
        arm_RandomFlagPos()

def arm_CalculateScore(playerDiff):
        
        # Calculate new flag capture score. Flag score is held in g_armadaPlayerCount[0]
        # playerDiff will be positive if pegleg have advantage, negative if undead do
        # Some calculation to work out the new flag capture
        
        if g_bfp2gamestate == 1:
        
                if playerDiff > 0: #positive
                        
                        newScore = 100/(45*pow(int(playerDiff),-0.3))
                        g_armadaPlayerCount[0] += newScore
                        emphprnt("The Peglegs have this battle -" + str(int(g_armadaPlayerCount[0])) + "% won")
                        
                elif playerDiff < 0: #negative
                        
                        UndeadplayerDiff = playerDiff*-1
                        newScore = 100/(45*pow(int(UndeadplayerDiff),-0.3))
                        g_armadaPlayerCount[0] -= newScore
                        emphprnt("The Undead have this battle " + str(int(g_armadaPlayerCount[0])) + "% won")
                
                # Move Armada Indicator
                if g_armadaPlayerCount[0] < 0: #Peglegs in control
                        newRotation = 90.0
                        newHeight = g_armadaPointsY[g_armadaCurPoint] - 11 - int(g_armadaPlayerCount[0]/10)
                else:
                        newRotation = 0.0
                        newHeight = g_armadaPointsY[g_armadaCurPoint] - 11 + int(g_armadaPlayerCount[0]/10)
                
                armInd = bf2.objectManager.getObjectsOfTemplate('armadaindicator')
                if len(armInd) > 0:
                        for indicator in armInd:
                                indicator.setPosition( (g_armadaPointsX[g_armadaCurPoint],newHeight,g_armadaPointsZ[g_armadaCurPoint]) )
                                indicator.setRotation( (newRotation,0.0,0.0) )
                
                if g_armadaPlayerCount[0] > 75:
                        bf2.gameLogic.setTicketState(2, 1)
                if g_armadaPlayerCount[0] > 100:
                        arm_battlewon(2)
                if g_armadaPlayerCount[0] < -75:
                        bf2.gameLogic.setTicketState(1, 1)
                if g_armadaPlayerCount[0] < -100:
                        arm_battlewon(1)   

def arm_onArmTrigger(triggerId, cp, vehicle, enter, userData):
        
        
        
        if triggerId == g_armadaIdPoints[g_armadaCurPoint]:
                
                prnt(str(cp.templateName))
                prnt(str(triggerId))
                
                for acp in g_controlPoints:
                        
                        if acp.templateName == "ArmadaFlag":
                                
                                prnt("B")
                                
                                #Count people in radius
                                team1Occupants = 0
                                team2Occupants = 0
                                pcos = bf2.triggerManager.getObjects(triggerId)
                                for o in pcos:
                                        if not o: continue                                      #You can get None in the result tuple when the host can't figure out what object left the trigger
                                        if o.getParent(): continue                              #GetOccupyingPlayers returns all players downwards in the hierarchy, so dont count them twice
                                        occupyingPlayers = o.getOccupyingPlayers()
                                        for p in occupyingPlayers:
                                                if p.isAlive() and not p.isManDown():           #Count the number of players who are alive
                                                        if not p.killed:
                                                                if p.getTeam() == 1:
                                                                        team1Occupants += 1
                                                                elif p.getTeam() == 2:
                                                                        team2Occupants += 1
                                #Determine who is taking control
                                team1OverWeight = team1Occupants - team2Occupants
                                prnt("overweight: "+str(team1OverWeight))
                                attackOverWeight = 0
                                takeOverChangePerSecond = 0
                                if team1OverWeight > 0:
                                        attackingTeam = 1                                       #Undead have advantage
                                        takeOverChangePerSecond = 1/(10*pow(int(team1OverWeight),-0.3))
                                elif team1OverWeight < 0:
                                        attackingTeam = 2                                       #Pegleg have advantage
                                        team2OverWeight = - team1OverWeight
                                        takeOverChangePerSecond = 1/(10*pow(int(team2OverWeight),-0.3)) 
                                else:
                                        attackingTeam = 0                                       #No advantage
                                        takeOverChangePerSecond = 0 
                                prnt("takeover: "+str(takeOverChangePerSecond))
                                acp.cp_setParam('takeOverChangePerSecond', takeOverChangePerSecond)

#
#DEFENITIONS for TIMERS
#

def onCTFTimer(data):
        
        if g_bfp2gamemodetype == 1:                                             #Gametype = CTF
                updateFlags()
                checkforsanity()

def onZombieTimer(data):
        
        global g_zombieTimer
        
        if g_bfp2gamemodetype == 2:                                             #Gametype = ZM
                if g_zombieTimer != -1:
                        if g_zombieTimer == 0:
                                emphprnt("Game starting now...")
                                zm_shuffleup()
                        else:
                                bf2.gameLogic.setTickets(1, g_zombieTimer)
                                bf2.gameLogic.setTickets(2, g_zombieTimer)
                                if g_zombieTimer == 60:
                                        emphprnt("The game will be starting in 1 minute")
                                if g_zombieTimer == 50:
                                        emphprnt("The game will be starting in " + str( g_zombieTimer ) + " seconds")
                                if g_zombieTimer == 40:
                                        emphprnt("The game will be starting in " + str( g_zombieTimer ) + " seconds")
                                if g_zombieTimer == 30:
                                        emphprnt("The game will be starting in " + str( g_zombieTimer ) + " seconds")
                                if g_zombieTimer == 20:
                                        emphprnt("The game will be starting in " + str( g_zombieTimer ) + " seconds")
                                if g_zombieTimer == 10:
                                        emphprnt("The game will be starting in " + str( g_zombieTimer ) + " seconds")
                                if g_zombieTimer == 5:
                                        emphprnt("The game will be starting in " + str( g_zombieTimer ) + " seconds")
                                if g_zombieTimer == 3:
                                        emphprnt("The game will be starting in " + str( g_zombieTimer ) + " seconds")
                                if g_zombieTimer == 2:
                                        emphprnt("The game will be starting in " + str( g_zombieTimer ) + " seconds")
                                if g_zombieTimer == 1:
                                        emphprnt("The game will be starting in " + str( g_zombieTimer ) + " second")
                                g_zombieTimer -= 1
                else:
                        zm_settickets()

def onArmadaTimer(data):
        
        global g_armadaPlayerCount
        
        try:
                if g_bfp2gamemodetype == 3:                                             #Gametype = ARMADA
                        
                        # Routine to win/loose battle
                        # g_armadaPlayerCount[0] is used to define who is winning this battle
                        # if its -ve then undead are winning, +ve and the peglegs are
                        
                        if g_bfp2gamestate == 1:
                                
                                g_armadaPlayerCount[1] = 0
                                g_armadaPlayerCount[2] = 0
                                
                                pcos = bf2.triggerManager.getObjects(g_armadaIdPoints[g_armadaCurPoint])
                                for o in pcos:
                                        if not o: continue                                      #You can get None in the result tuple when the host can't figure out what object left the trigger
                                        if o.getParent(): continue                              #GetOccupyingPlayers returns all players downwards in the hierarchy, so dont count them twice
                                        occupyingPlayers = o.getOccupyingPlayers()
                                        for p in occupyingPlayers:
                                                if p.isAlive() and not p.isManDown():           #Count the number of players who are alive
                                                        if not p.killed:
                                                                p.isInRange = True
                                                                g_armadaPlayerCount[p.getTeam()] += 1
                                
                                playerDiff = g_armadaPlayerCount[2] - g_armadaPlayerCount[1]
                                resetFlagPos = False
                                
                                if g_armadaPlayerCount[0] > 0:                                  # peglegs are currently winning
                                        if g_armadaPlayerCount[2] == 0:                         # no peglegs left reset flag
                                                resetFlagPos = True
                                        else:                                                   # some peglegs left and not yet won
                                                if playerDiff != 0:
                                                        arm_CalculateScore(playerDiff)
                                
                                if g_armadaPlayerCount[0] < 0:                                  # undead are currently winning
                                        if g_armadaPlayerCount[1] == 0:                         # no undead left reset flag
                                                resetFlagPos = True
                                        else:                                                   # some undead left and not yet won
                                                if playerDiff != 0:
                                                        arm_CalculateScore(playerDiff)
                                
                                if g_armadaPlayerCount[0] == 0:                                 # score is 0
                                        resetFlagPos = True
                                
                                if resetFlagPos == True:                                        # score is 0, calculate score
                                        g_armadaPlayerCount[0] = 0
                                        if playerDiff != 0:
                                                arm_CalculateScore(playerDiff)
        except:
                if g_debug: debug.exception()

def onGeneralTimer(data):
        
        global g_intervalNum
        
        # Routines to add triggers to frigates etc
        if g_intervalNum == 0:
                
                #Routine to add triggers to Frigates
                frigatesPeg = bf2.objectManager.getObjectsOfTemplate('frigate')
                index = len(frigatesPeg)
                if index > 0:
                        for fPeg in frigatesPeg:
                                if not hasattr(fPeg, 'isMarked'):
                                        if str( fPeg.getPosition() ) != "(0.0, 0.0, 0.0)":
                                                fPegChildren = fPeg.getChildren()
                                                for fPegChild in fPegChildren:
                                                        if str ( fPegChild.templateName ) == 'frigate_Trigger':
                                                                bf2.triggerManager.createHemiSphericalTrigger(fPegChild, onFrigateTrigger, '<<PCO>>', 9.7, (1, 2, 3))
                                                                fPeg.isMarked = True
        if g_intervalNum == 1:
                        
                #Routine to add triggers to Frigates
                frigatesUd = bf2.objectManager.getObjectsOfTemplate('frigate2')
                index = len(frigatesUd)
                if index > 0:
                        for fUd in frigatesUd:
                                if not hasattr(fUd, 'isMarked'):
                                        if str( fUd.getPosition() ) != "(0.0, 0.0, 0.0)":
                                                fUdChildren = fUd.getChildren()
                                                for fUdChild in fUdChildren:
                                                        if str ( fUdChild.templateName ) == 'frigate2_Trigger':
                                                                bf2.triggerManager.createHemiSphericalTrigger(fUdChild, onFrigateTrigger, '<<PCO>>', 9.7, (1, 2, 3))
                                                                fUd.isMarked = True
        if g_intervalNum == 2:
                
                #Routine to add triggers to Brig
                brigsPeg = bf2.objectManager.getObjectsOfTemplate('brig')
                index = len(brigsPeg)
                if index > 0:
                        for bPeg in brigsPeg:
                                if not hasattr(bPeg, 'isMarked'):
                                        if str( bPeg.getPosition() ) != "(0.0, 0.0, 0.0)":
                                                bPegChildren = bPeg.getChildren()
                                                for bPegChild in bPegChildren:
                                                        if str ( bPegChild.templateName ) == 'brig_Trigger':
                                                                bf2.triggerManager.createHemiSphericalTrigger(bPegChild, onBrigTrigger, '<<PCO>>', 4.5, (1, 2, 3))
                                                                bPeg.isMarked = True
        if g_intervalNum == 3:
                        
                #Routine to add triggers to Brig
                brigsUd = bf2.objectManager.getObjectsOfTemplate('brig2')
                index = len(brigsUd)
                if index > 0:
                        for bUd in brigsUd:
                                if not hasattr(bUd, 'isMarked'):
                                        if str( bUd.getPosition() ) != "(0.0, 0.0, 0.0)":
                                                bUdChildren = bUd.getChildren()
                                                for bUdChild in bUdChildren:
                                                        if str ( bUdChild.templateName ) == 'brig2_Trigger':
                                                                bf2.triggerManager.createHemiSphericalTrigger(bUdChild, onBrigTrigger, '<<PCO>>', 4.5, (1, 2, 3))
                                                                bUd.isMarked = True
        if g_intervalNum == 4:
                        
                #Routine to add triggers to Cutter
                cuttersPeg = bf2.objectManager.getObjectsOfTemplate('cutter')
                index = len(cuttersPeg)
                if index > 0:
                        for cPeg in cuttersPeg:
                                if not hasattr(cPeg, 'isMarked'):
                                        if str( cPeg.getPosition() ) != "(0.0, 0.0, 0.0)":
                                                cPegChildren = cPeg.getChildren()
                                                for cPegChild in cPegChildren:
                                                        if str ( cPegChild.templateName ) == 'cutter_Trigger':
                                                                bf2.triggerManager.createHemiSphericalTrigger(cPegChild, onCutterTrigger, '<<PCO>>', 3.8, (1, 2, 3))
                                                                cPeg.isMarked = True
        if g_intervalNum == 5:
                
                #Routine to add triggers to Cutter
                cuttersUd = bf2.objectManager.getObjectsOfTemplate('cutter2')
                index = len(cuttersUd)
                if index > 0:
                        for cUd in cuttersUd:
                                if not hasattr(cUd, 'isMarked'):
                                        if str( cUd.getPosition() ) != "(0.0, 0.0, 0.0)":
                                                cUdChildren = cUd.getChildren()
                                                for cUdChild in cUdChildren:
                                                        if str ( cUdChild.templateName ) == 'cutter2_Trigger':
                                                                bf2.triggerManager.createHemiSphericalTrigger(cUdChild, onCutterTrigger, '<<PCO>>', 3.8, (1, 2, 3))
                                                                cUd.isMarked = True
        if g_intervalNum == 6:
                
                #Show a random pegleg postion if desired
                if g_usePeglegLocator == 1:
                        if g_bfp2gamemodetype == 2 and g_bfp2gamestate == 2: #Gametype = ZM and Started
                                #Pick a random player from all alive pegleg players
                                if bf2.playerManager.getNumberOfAlivePlayersInTeam(2) > 0:
                                        peglegPlayer = random.choice([p for p in bf2.playerManager.getPlayers() if p.getTeam() == 2 and p.isAlive() and not p.isManDown()])
                                        #move pegleglocator XZ to peglegplayer
                                        newPos = peglegPlayer.getVehicle().getPosition()
                                        plpositions = bf2.objectManager.getObjectsOfTemplate('pegleglocator')
                                        if len(plpositions) > 0:
                                                for plpos in plpositions:
                                                        if str( plpos.getPosition() ) != "(0.0, 0.0, 0.0)":
                                                                curPos = plpos.getPosition()
                                                                plpos.setPosition( (newPos[0], curPos[1], newPos[2]) )
                                                                #Host.sgl_sendTextMessage(1, 13, 1, "Yarr, human flesh has been smelt", 1 )
        if g_intervalNum == 7:
                g_intervalNum = 0
        else:
                g_intervalNum += 1
        

#
#DEFENITIONS for GENERAL USE
#

#PRINT MESSAGE TO ALL PLAYERS - YELLOW
def prnt(msg):
	msg = msg.replace("\"", "'")
	host.sgl_sendTextMessage(0, 12, 1, msg, 0)
	#host.rcon_invoke("game.sayAll \"" + str(msg) + "\"")                    #Send message to the game window

#PRINT MESSAGE TO ALL PLAYERS - YELLOW     
def emphprnt(msg):
	msg = msg.replace("\"", "'")
	prnt("--------------------------------")                                #Send message wrapped in bars
	prnt(" ")
	prnt(msg)
	prnt(" ")
	prnt("--------------------------------")
	
#Create Object
def create_object(object, team, posX, posY, posZ, rotX, rotY, rotZ):

        #create gun effect
        host.rcon_invoke("ObjectTemplate.create ObjectSpawner " + str(object) + "Spawner")
        host.rcon_invoke("ObjectTemplate.activeSafe ObjectSpawner " + str(object) + "Spawner")
        host.rcon_invoke("ObjectTemplate.isNotSaveable 1")
        host.rcon_invoke("ObjectTemplate.hasMobilePhysics 0")
        host.rcon_invoke("ObjectTemplate.setObjectTemplate " + str(team) + " " + str(object) )
        host.rcon_invoke("Object.create " + str(object) + "Spawner")
        host.rcon_invoke("Object.absolutePosition " + str(posX) + "/" + str(posY) + "/" + str(posZ) )
        host.rcon_invoke("Object.rotation " + str(rotX) + "/" + str(rotY) + "/" + str(rotZ) )
        host.rcon_invoke("Object.team " + str(team))
        host.rcon_invoke("Object.delete")

#Delete Object
def delete_object(object,location):
        
        try:
                result = host.rcon_invoke("Object.listObjectsOfTemplate " + str(object))
                for line in result.split("\n"):
                        parts = line.split(" ")
                        if len(parts) != 10: return
                        objectID = parts[3]
                        # if call uses location then check it otherwise skip
                        if location != "0":
                                # set active object, and get position
                                host.rcon_invoke("Object.active id" + str(objectID))
                                absPos = host.rcon_invoke("Object.absolutePosition")
                                posparts = absPos.split("/")
                                if len(posparts) != 3: return
                                objPos = map(float, posparts)
                                # compare to given object position, delete object if reasonably close (0.01m)
                                if game.common.vectorcompare(location, objPos, 0.01) == True:
                                        host.rcon_invoke("Object.active id" + str(objectID))
                                        host.rcon_invoke("Object.delete")
                        else:
                                host.rcon_invoke("Object.active id" + str(objectID))
                                host.rcon_invoke("Object.delete")
        except:
                prnt("Error Deleting Object")
                
def get_rank(playerID):
        
        try:
                sServer = "bfpirates.com"
                sPort = 80
                
                trufile = str(playerID)
                length = len(trufile)
                
                message = "POST /stats/getrank.php HTTP/1.0\nAccept: */*\nAccept-Language: EN\nHost: "+str(sServer)+"\nContent-type: application/octet-stream\nContent-length: "+str(length)+"\n\n"+str(trufile)
                
                sock = socket(AF_INET, SOCK_STREAM)
                sock.settimeout(8.0)
                
                try:
                    sock.connect((sServer, sPort))
                except:
                    print("Stat Error - Could not connect to stat server")
                    sock.close()
                    return "0:0"
                
                messlen = 0
                tries = 0
                fail = 0
                data = ""
                
                while messlen < len(message):
                    tries += 1
                    
                    if tries >= 2:
                        fail = 1
                        break
                    
                    try: messlen += sock.send(message)
                    except:
                        ExceptionOutput()
                    if messlen != len(message):
                        print("Send looping...")
                        
                if fail == 0:
                    data = ""
                        
                    try:
                        data = sock.recv(1024)
                        result = data.split("||bfp2||")[1]
                        sock.close()
                        return result
                    
                    except:
                        print "Failed to Retrieve Data"
                
                sock.close()
                return "0:0"
        
        except:
                return "0:0"
        
def playCTFSound(wavFile,timePlus):
        
        newHeight = 120.00 + int(timePlus)
        create_object("gameplayctf_"+str(wavFile),"1","0.00",timePlus,"0.00","0.00","0.00","0.00")

def playZMSound(wavFile):
        
        create_object("gameplayzm_"+str(wavFile),"1","0.00","120.00","0.00","0.00","0.00","0.00")

def delay_gameover(a,b):
        
        host.sgl_endGame(a, b)
        
### TIMER CLASS

class timer(object):

    class once(object):

        def __init__(self, time, method, *args):
            self.time = host.timer_getWallTime() + time
            self.interval = 0
            self.alwaysTrigger = 1
            self.method = method
            self.args = args
            host.timer_created(self)

        def onTrigger(self):
            self.method(*self.args)
            self.abort()

        def abort(self):
            host.timer_destroy(self)

    class loop(object):

        def __init__(self, time, method, *args):
            self.__dict__['time'] = host.timer_getWallTime() + time
            self.interval = time
            self.alwaysTrigger = 1
            self.method = method
            self.args = args
            host.timer_created(self)

        def __setattr__(self, name, value):
            if name != "time":
                self.__dict__[name] = value

        def onTrigger(self):
            self.method(*self.args)
            self.__dict__['time'] += self.interval

        def abort(self):
            host.timer_destroy(self)
