# constants.py -- vehicle/weapon/kit types for EOR and scoring.
# By Pirateplunder for BFP2, based on original work by DICE, worked out by [poe2]seigman, [dcon]kiff and [FH2]ctz

import host
import string

VEHICLE_TYPE_HEAVYSAIL	= 0
VEHICLE_TYPE_LIGHTSAIL  = 1
VEHICLE_TYPE_ROW	= 2
VEHICLE_TYPE_AIR	= 3
VEHICLE_TYPE_HEAVYCANNON= 4
VEHICLE_TYPE_SPECIAL    = 5
VEHICLE_TYPE_LIGHTCANNON= 6

VEHICLE_TYPE_PARACHUTE	= 7
VEHICLE_TYPE_SOLDIER	= 8

VEHICLE_TYPE_NIGHTVISION= 9
VEHICLE_TYPE_GASMASK	= 10

NUM_VEHICLE_TYPES 	= 11
VEHICLE_TYPE_UNKNOWN 	= NUM_VEHICLE_TYPES

VEHICLE_TYPE_names = {
    VEHICLE_TYPE_HEAVYSAIL:   'Heavy Sail',
    VEHICLE_TYPE_LIGHTSAIL:   'Light Sail',
    VEHICLE_TYPE_ROW:         'Row Boat',
    VEHICLE_TYPE_AIR:         'Air',
    VEHICLE_TYPE_HEAVYCANNON: 'Heavy Cannon',
    VEHICLE_TYPE_LIGHTCANNON: 'Light Cannon', 
    VEHICLE_TYPE_SPECIAL:     'Specialist',
    VEHICLE_TYPE_PARACHUTE:   'Parachute',
    VEHICLE_TYPE_SOLDIER:     'Soldier',
    VEHICLE_TYPE_NIGHTVISION: 'Night Vision',
    VEHICLE_TYPE_GASMASK:     'Gas Mask',
}


WEAPON_TYPE_MUSKET	= 0
WEAPON_TYPE_MUSKETOON	= 1
WEAPON_TYPE_BLUNDERBUSS	= 2
WEAPON_TYPE_NOCK        = 3
WEAPON_TYPE_SNIPER	= 4
WEAPON_TYPE_HEAVYPISTOL	= 5
WEAPON_TYPE_LIGHTPISTOL	= 6
WEAPON_TYPE_LAUNCHER	= 7
WEAPON_TYPE_FLARE	= 8
WEAPON_TYPE_CRAB	= 9
WEAPON_TYPE_CUTLASS	= 10
WEAPON_TYPE_AXE		= 11
WEAPON_TYPE_BARREL	= 12
WEAPON_TYPE_HANDGRENADE = 13
WEAPON_TYPE_PARROT	= 14
WEAPON_TYPE_SMOKE	= 15
WEAPON_TYPE_TARGETING	= 16

WEAPON_TYPE_GRAPPLINGHOOK=17
WEAPON_TYPE_ZIPLINE	=18

WEAPON_TYPE_TACTICAL	=19

WEAPON_TYPE_DUCKSFOOT   =20

NUM_WEAPON_TYPES 	= 21
WEAPON_TYPE_UNKNOWN	= NUM_WEAPON_TYPES


WEAPON_TYPE_names = {
    WEAPON_TYPE_MUSKET:		'Musket',
    WEAPON_TYPE_MUSKETOON:	'Musketoon',
    WEAPON_TYPE_BLUNDERBUSS:	'Blunderbuss',
    WEAPON_TYPE_NOCK:		'Nock Gun',
    WEAPON_TYPE_SNIPER:		'Sniper Musket',
    WEAPON_TYPE_HEAVYPISTOL:	'Heavy Pistol',
    WEAPON_TYPE_LIGHTPISTOL:	'Light Pistol',
    WEAPON_TYPE_LAUNCHER:	'Hand Cannon',
    WEAPON_TYPE_FLARE:		'Flare',
    WEAPON_TYPE_CRAB:		'Crab',
    WEAPON_TYPE_CUTLASS:	'Cutlass',
    WEAPON_TYPE_AXE:		'Boarding Axe',
    WEAPON_TYPE_BARREL:		'Barrel',
    WEAPON_TYPE_HANDGRENADE:    'Grenade',
    WEAPON_TYPE_PARROT:		'Parrot',
    WEAPON_TYPE_SMOKE:		'Smoke Jar',
    WEAPON_TYPE_TARGETING:	'Targeting',
    WEAPON_TYPE_GRAPPLINGHOOK:	'Grapple',
    WEAPON_TYPE_ZIPLINE:	'Zip Rope',
    WEAPON_TYPE_TACTICAL:	'Tactical',
    WEAPON_TYPE_DUCKSFOOT:      'Ducksfoot',
}

KIT_TYPE_RAIDER         = 0
KIT_TYPE_CARPENTER	= 1
KIT_TYPE_GUNNER		= 2
KIT_TYPE_SCOUT		= 3
KIT_TYPE_SHARPSHOOTER	= 4
KIT_TYPE_SURGEON	= 5
KIT_TYPE_SPECIALIST	= 6

NUM_KIT_TYPES		= 7
KIT_TYPE_UNKNOWN	= NUM_KIT_TYPES

KIT_TYPE_names = {
    KIT_TYPE_SPECIALIST:	'Specialist',
    KIT_TYPE_RAIDER:		'Raider',
    KIT_TYPE_CARPENTER:		'Carpenter',
    KIT_TYPE_SURGEON:		'Surgeon',
    KIT_TYPE_SCOUT:		'Scout',
    KIT_TYPE_GUNNER:		'Gunner',
    KIT_TYPE_SHARPSHOOTER:	'Sharpshooter',
}

ARMY_UD			= 0
ARMY_PL			= 1

NUM_ARMIES		= 2
ARMY_UNKNOWN		= NUM_ARMIES

ARMY_names = {
    ARMY_UD: 'Undead',
    ARMY_PL: 'Pegleg',
}

# for vehicles which may commonly cause accidental passenger tks
ignoreTKsFromVehicles = ['ju52', 'landingcraftassault']

vehicleTypeMap = {
	"mortar01"		: VEHICLE_TYPE_HEAVYCANNON,
	"mortar02"		: VEHICLE_TYPE_HEAVYCANNON,
	"12pdrcannon01"		: VEHICLE_TYPE_HEAVYCANNON,
	"12pdrcannon02"		: VEHICLE_TYPE_HEAVYCANNON,
	"24_pounder"		: VEHICLE_TYPE_HEAVYCANNON,
	"2pdrfalc90d"		: VEHICLE_TYPE_LIGHTCANNON,
	"2pdrfalc"		: VEHICLE_TYPE_LIGHTCANNON,
	"portcannon"		: VEHICLE_TYPE_LIGHTCANNON,
	"portcannon90d"		: VEHICLE_TYPE_LIGHTCANNON,
	"portcannon180d"	: VEHICLE_TYPE_LIGHTCANNON,
	"spawnfalc"		: VEHICLE_TYPE_LIGHTCANNON,
	"carronade"		: VEHICLE_TYPE_LIGHTCANNON,
	"6pdrcannon01"		: VEHICLE_TYPE_LIGHTCANNON,
	"6pdrcannon02"		: VEHICLE_TYPE_LIGHTCANNON,
	"6pdrfieldcannon01"	: VEHICLE_TYPE_LIGHTCANNON,
	"6pdrfieldcannon02"	: VEHICLE_TYPE_LIGHTCANNON,
	"smallbaloon"		: VEHICLE_TYPE_AIR,
	"biergleiter"		: VEHICLE_TYPE_AIR,
	"brig"			: VEHICLE_TYPE_HEAVYSAIL,
	"brig2"			: VEHICLE_TYPE_HEAVYSAIL,
	"cutter"		: VEHICLE_TYPE_LIGHTSAIL,
	"cutter2"		: VEHICLE_TYPE_LIGHTSAIL,
	"dinghy"		: VEHICLE_TYPE_ROW,
	"dinghy2"		: VEHICLE_TYPE_ROW,
	"gnat"			: VEHICLE_TYPE_ROW,
	"gnat2"			: VEHICLE_TYPE_ROW,
	"runabout"		: VEHICLE_TYPE_LIGHTSAIL,
	"runabout2"		: VEHICLE_TYPE_LIGHTSAIL,
	"wherry"		: VEHICLE_TYPE_LIGHTSAIL,
	"wherry2"		: VEHICLE_TYPE_LIGHTSAIL,
	"dolphinvehicle"	: VEHICLE_TYPE_SPECIAL,
	"frigate"		: VEHICLE_TYPE_HEAVYSAIL,
	"frigate2"		: VEHICLE_TYPE_HEAVYSAIL,
	"boat_rib"		: VEHICLE_TYPE_SPECIAL,
	"ud_gunr"		: VEHICLE_TYPE_SOLDIER,
	"ud_gunr_ctf"		: VEHICLE_TYPE_SOLDIER,
	"ud_gunrrpeg"		: VEHICLE_TYPE_SOLDIER,
	"ud_radr"		: VEHICLE_TYPE_SOLDIER,
	"ud_radrrpeg_ctf"	: VEHICLE_TYPE_SOLDIER,
	"ud_radrrpeg"		: VEHICLE_TYPE_SOLDIER,
	"ud_shrp"		: VEHICLE_TYPE_SOLDIER,
	"ud_shrp_ctf"		: VEHICLE_TYPE_SOLDIER,
	"ud_shrprpeg"		: VEHICLE_TYPE_SOLDIER,
	"ud_surg"		: VEHICLE_TYPE_SOLDIER,
	"ud_surgrpeg_ctf"	: VEHICLE_TYPE_SOLDIER,
	"ud_surgrpeg"		: VEHICLE_TYPE_SOLDIER,
	"pl_carp"		: VEHICLE_TYPE_SOLDIER,
	"pl_carppeg_ctf"	: VEHICLE_TYPE_SOLDIER,
	"pl_carppeg"		: VEHICLE_TYPE_SOLDIER,
	"pl_gunr"		: VEHICLE_TYPE_SOLDIER,
	"pl_gunr_ctf"		: VEHICLE_TYPE_SOLDIER,
	"pl_gunrpeg"		: VEHICLE_TYPE_SOLDIER,
	"pl_radr"		: VEHICLE_TYPE_SOLDIER,
	"pl_radr_ctf"		: VEHICLE_TYPE_SOLDIER,
	"pl_radrpeg"		: VEHICLE_TYPE_SOLDIER,
	"pl_shrp"		: VEHICLE_TYPE_SOLDIER,
	"pl_shrppeg_ctf"	: VEHICLE_TYPE_SOLDIER,
	"pl_shrppeg"		: VEHICLE_TYPE_SOLDIER,
	"pl_surg"		: VEHICLE_TYPE_SOLDIER,
	"pl_surg_ctf"		: VEHICLE_TYPE_SOLDIER,
	"pl_surgpeg"		: VEHICLE_TYPE_SOLDIER,	
	"parachute"		: VEHICLE_TYPE_PARACHUTE,
}

weaponTypeMap = {
	"musket"		: WEAPON_TYPE_MUSKET,
	"sniper_musket"		: WEAPON_TYPE_SNIPER,
	"musketoon"		: WEAPON_TYPE_MUSKETOON,
	"blunderbuss"		: WEAPON_TYPE_BLUNDERBUSS,
	"nockgun"		: WEAPON_TYPE_NOCK,
	"grenadelauncher"	: WEAPON_TYPE_LAUNCHER,
	"grenade"		: WEAPON_TYPE_HANDGRENADE,
	"flarelauncher"		: WEAPON_TYPE_FLARE,
	"ducksfoot"		: WEAPON_TYPE_DUCKSFOOT,
	"dualfrenchpistol"	: WEAPON_TYPE_LIGHTPISTOL,
	"cutlass1"		: WEAPON_TYPE_CUTLASS,
	"cutlass2"		: WEAPON_TYPE_CUTLASS,
	"crab4"			: WEAPON_TYPE_CRAB,
	"boardingaxe"		: WEAPON_TYPE_AXE,
	"piratepistol"		: WEAPON_TYPE_HEAVYPISTOL,
	"potionjar"		: WEAPON_TYPE_SMOKE,
	"powderkeg2"		: WEAPON_TYPE_BARREL,
	"sfrenchpistol"		: WEAPON_TYPE_LIGHTPISTOL,
	"smokejar"		: WEAPON_TYPE_SMOKE,
	"throwingaxe"		: WEAPON_TYPE_AXE,
	"parrotaamis"		: WEAPON_TYPE_PARROT,
	"nshgr_flashbang"	: WEAPON_TYPE_TACTICAL,
	"ziprope_crossbow"	: WEAPON_TYPE_ZIPLINE,
}

kitTypeMap = {
	"pl_carpenter"		: KIT_TYPE_CARPENTER,
	"pl_carpenterdc"	: KIT_TYPE_CARPENTER,
	"pl_heavygunner"	: KIT_TYPE_GUNNER,
	"pl_gunnerdc"		: KIT_TYPE_GUNNER,
	"pl_raider"		: KIT_TYPE_RAIDER,
	"pl_raiderdc"		: KIT_TYPE_RAIDER,
	"pl_scout"		: KIT_TYPE_SCOUT,
	"pl_scoutdc"	 	: KIT_TYPE_SCOUT,
	"pl_sharpshooter"	: KIT_TYPE_SHARPSHOOTER,
	"pl_sharpshooterdc"	: KIT_TYPE_SHARPSHOOTER,
	"pl_surgeon"		: KIT_TYPE_SURGEON,
	"pl_surgeondc"		: KIT_TYPE_SURGEON,
	"pl_gunner"		: KIT_TYPE_GUNNER,
	"pl_lightgunner"	: KIT_TYPE_GUNNER,
	"ud_carpenter"		: KIT_TYPE_CARPENTER,
	"ud_carpenterdc"	: KIT_TYPE_CARPENTER,
	"ud_heavygunner"	: KIT_TYPE_GUNNER,
	"ud_gunnerdc"		: KIT_TYPE_GUNNER,
	"ud_raider"		: KIT_TYPE_RAIDER,
	"ud_raiderdc"		: KIT_TYPE_RAIDER,
	"ud_scout"		: KIT_TYPE_SCOUT,
	"ud_scoutdc"	 	: KIT_TYPE_SCOUT,
	"ud_sharpshooter"	: KIT_TYPE_SHARPSHOOTER,
	"ud_sharpshooterdc"	: KIT_TYPE_SHARPSHOOTER,
	"ud_surgeon"		: KIT_TYPE_SURGEON,
	"ud_surgeondc"		: KIT_TYPE_SURGEON,
	"ud_gunner"		: KIT_TYPE_GUNNER,
	"ud_lightgunner"	: KIT_TYPE_GUNNER,
	"ud_zombie"		: KIT_TYPE_SPECIALIST,
	"antiairpu_1"		: KIT_TYPE_SPECIALIST,
	"grapplepu_1"		: KIT_TYPE_SPECIALIST,
	"zipropepu_1"		: KIT_TYPE_SPECIALIST,
}

armyMap = {
	"ud"		: ARMY_UD,
	"pl"		: ARMY_PL,
}

mapMap = {
}
UNKNOWN_MAP = 99

gameModeMap = {
	"gpm_cq"		: 0,
	"gpm_pirates"		: 1,
}
UNKNOWN_GAMEMODE = 99



def getVehicleType(templateName):
    try:
        vehicleType = vehicleTypeMap[string.lower(templateName)]
    except KeyError:
        return VEHICLE_TYPE_UNKNOWN
    
    return vehicleType


    
def getWeaponType(templateName):
    try:
        weaponType = weaponTypeMap[string.lower(templateName)]
    except KeyError:
        return WEAPON_TYPE_UNKNOWN
    
    return weaponType   
    
    
    
def getKitType(templateName):
    try:
        kitType = kitTypeMap[string.lower(templateName)]
    except KeyError:
        return KIT_TYPE_UNKNOWN
    
    return kitType  
    
    
    
def getArmy(templateName):
    try:
        army = armyMap[string.lower(templateName)]
    except KeyError:
        return ARMY_UNKNOWN
    
    return army



def getMapId(mapName):
    try:
        mapId = mapMap[string.lower(mapName)]
    except KeyError:
        return UNKNOWN_MAP
    
    return mapId



def getGameModeId(gameMode):
    try:
        gameModeId = gameModeMap[string.lower(gameMode)]
    except KeyError:
        return UNKNOWN_GAMEMODE
    
    return gameModeId



def getRootParent(obj):
    parent = obj.getParent()
    
    if parent == None:
        return obj
        
    return getRootParent(parent)

print "BFP2 Stat constants loaded"