import host
import bf2.PlayerManager
import bf2.GameLogic
import sys
import socket
import md5
import inspect
import re
import ConfigParser
import errno

from game.stats.constants import *
from socket import *

bfp2_statcode = "off1ppds"

EOR_DEBUG = 1
g_debug = EOR_DEBUG

"""
KIT_TYPE_AT         = 0
KIT_TYPE_ASSAULT    = 1
KIT_TYPE_ENGINEER   = 2
KIT_TYPE_MEDIC      = 3
KIT_TYPE_SPECOPS    = 4
KIT_TYPE_SUPPORT    = 5
KIT_TYPE_SNIPER     = 6

at -> raider
assault -> carpenter
engineer -> gunner
medic -> scout
specops -> sharpshooter
support -> surgeon
sniper -> specialist
"""
eor_kits = {
  0: [KIT_TYPE_RAIDER],
  1: [KIT_TYPE_CARPENTER],
  2: [KIT_TYPE_GUNNER],
  3: [KIT_TYPE_SCOUT],
  4: [KIT_TYPE_SHARPSHOOTER],
  5: [KIT_TYPE_SURGEON],
  6: [KIT_TYPE_SPECIALIST],
}

"""
VEHICLE_TYPE_ARMOR      = 0
VEHICLE_TYPE_AVIATOR    = 1
VEHICLE_TYPE_AIRDEFENSE = 2
VEHICLE_TYPE_HELICOPTER = 3
VEHICLE_TYPE_TRANSPORT  = 4
VEHICLE_TYPE_ARTILLERY  = 5
VEHICLE_TYPE_GRNDDEFENSE= 6

armor -> heavy sail
aviator -> light sail
airdefense -> row boat
helicopter -> air
transport -> Heavy Cannon
artillery -> Not Shown
ground defense -> Light Cannon
"""
eor_vehicles = {
  0: [VEHICLE_TYPE_HEAVYSAIL],
  1: [VEHICLE_TYPE_LIGHTSAIL],
  2: [VEHICLE_TYPE_ROW],
  3: [VEHICLE_TYPE_AIR],
  4: [VEHICLE_TYPE_HEAVYCANNON],
  5: [VEHICLE_TYPE_SPECIAL],
  6: [VEHICLE_TYPE_LIGHTCANNON],
}

eor_weapons = {
  0: [WEAPON_TYPE_MUSKET],
  1: [WEAPON_TYPE_SNIPER],
  2: [WEAPON_TYPE_MUSKETOON],
  3: [WEAPON_TYPE_BLUNDERBUSS],
  4: [WEAPON_TYPE_NOCK],
  5: [WEAPON_TYPE_LAUNCHER],
  6: [WEAPON_TYPE_HANDGRENADE],
  7: [WEAPON_TYPE_FLARE],
  8: [WEAPON_TYPE_HEAVYPISTOL],
  9: [WEAPON_TYPE_LIGHTPISTOL],
  10: [WEAPON_TYPE_CUTLASS],
  11: [WEAPON_TYPE_CRAB],
  12: [WEAPON_TYPE_AXE],
  13: [WEAPON_TYPE_SMOKE],
  14: [WEAPON_TYPE_BARREL],
  15: [WEAPON_TYPE_PARROT],
  16: [WEAPON_TYPE_TACTICAL],
  17: [WEAPON_TYPE_ZIPLINE],
  18: [WEAPON_TYPE_DUCKSFOOT],
}

def invoke():
    if g_debug: print "Invoked bfp2 end-of-round data-send"
    
    # collect needed stats
    e = {}
    from game.stats.stats import getStatsMap
    statsMap = getStatsMap()
    
    # find top player in different categories
    for sp in statsMap.itervalues():
        if g_debug: print 'for', sp.name, '...'
        for k, cats in eor_kits.items():
            tio = 0.0
            score = 0
            for cat in cats:
                if cat in sp.kits:
                    tio += sp.kits[cat].timeInObject
                    score += sp.kits[cat].score
            if tio > 0.0:
                findTop(e, "sk" + str(k), "skn" + str(k), score, sp.name)

        for v, cats in eor_vehicles.items():
            tio = 0.0
            score = 0
            for cat in cats:
                if cat in sp.vehicles:
                    tio += sp.vehicles[cat].timeInObject
                    score += sp.vehicles[cat].score
            if tio > 0.0:
                findTop(e, "sv" + str(v), "svn" + str(v), score, sp.name)
            
        findTop(e, "ts", "tsn", sp.teamScore, sp.name)
        findTop(e, "ss", "ssn", sp.skillScore, sp.name)
        findTop(e, "cpc", "cpcn", sp.localScore.cpCaptures, sp.name)
        findTop(e, "cpa", "cpan", sp.localScore.cpAssists, sp.name)
        findTop(e, "cpd", "cpdn", sp.localScore.cpDefends, sp.name)
        findTop(e, "ka", "kan", sp.localScore.damageAssists + sp.localScore.targetAssists + sp.localScore.passengerAssists, sp.name)
        findTop(e, "he", "hen", sp.localScore.heals, sp.name)
        findTop(e, "rev", "revn", sp.localScore.revives, sp.name)
        findTop(e, "rsp", "rspn", sp.localScore.ammos, sp.name)
        findTop(e, "rep", "repn", sp.localScore.repairs, sp.name)
        findTop(e, "drs", "drsn", sp.localScore.driverSpecials + sp.localScore.driverAssists, sp.name)
        
    
    # find top-3
    if len(statsMap) > 0:
        sortedPlayers = []
        for sp in statsMap.itervalues():
            sortedPlayers += [((sp.score, sp.skillScore, -sp.deaths), sp)]
    
        sortedPlayers.sort()
        sortedPlayers.reverse()
        
        # stats for top-3 scoring players
        for i in range(3):
            if len(sortedPlayers) <= i:
                break
    
            sp = sortedPlayers[i][1]
            e["np" + str(i)] = sp.name
            e["tsp" + str(i)] = sp.teamScore
            e["ssp" + str(i)] = sp.skillScore
            e["csp" + str(i)] = sp.cmdScore
            e["bfp" + str(i)] = sp.bulletsFired
            e["bhp" + str(i)] = sp.bulletsHit
            
            for k, cats in eor_kits.items():
                ttl = 0
                for cat in cats:
                    ttl += sp.kits[cat].timeInObject
                if ttl > 0:
                    e["tk" + str(k) + "p" + str(i)] = int(ttl)
            
            for k, cats in eor_vehicles.items():
                ttl = 0
                for cat in cats:
                    ttl += sp.vehicles[cat].timeInObject
                if ttl > 0:
                    e["tv" + str(k) + "p" + str(i)] = int(ttl)
        
    keyvals = []
    for k in e:
        keyvals.append ("\\".join((k, str(e[k]))))

    dataString = "\\" + "\\".join(keyvals)
    
    if g_debug: print dataString
    host.gl_sendEndOfRoundData(dataString)
 
        
def findTop(e, vkey, nkey, value, name):
    if not vkey in e or value > e[vkey]:
        e[vkey] = value
        e[nkey] = name
